Package: spData
Title: Datasets for Spatial Analysis
Version: 2.3.4
Authors@R: c(person("Roger", "Bivand", role = "aut", email="Roger.Bivand@nhh.no", comment = c(ORCID = "0000-0003-2392-6140")),
    person("Jakub", "Nowosad", role = c("aut", "cre"), email="nowosad.jakub@gmail.com", comment = c(ORCID = "0000-0002-1057-3721")),
    person("Robin", "Lovelace", role = "aut", comment = c(ORCID = "0000-0001-5679-6536")),
    person("Angelos", "Mimis", role = "ctb"),
    person("Mark", "Monmonier", role = "ctb", comment = "author of the state.vbm dataset"), 
    person("Greg", "Snow", role = "ctb", comment = "author of the state.vbm dataset")
    )
Description: Diverse spatial datasets for demonstrating, benchmarking and teaching spatial data analysis. 
    It includes R data of class sf (defined by the package 'sf'), Spatial ('sp'), and nb ('spdep').
    Unlike other spatial data packages such as 'rnaturalearth' and 'maps', 
    it also contains data stored in a range of file formats including GeoJSON and GeoPackage, but from version 2.3.4, no longer ESRI Shapefile - use GeoPackage instead. 
    Some of the datasets are designed to illustrate specific analysis techniques.
    cycle_hire() and cycle_hire_osm(), for example, is designed to illustrate point pattern analysis techniques.
Depends: R (>= 3.3.0)
Imports: sp
Suggests: foreign, sf (>= 0.9-1), spDataLarge (>= 0.4.0), spdep,
        spatialreg
License: CC0
RoxygenNote: 7.3.2
LazyData: true
URL: https://jakubnowosad.com/spData/
BugReports: https://github.com/Nowosad/spData/issues
Additional_repositories: https://jakubnowosad.com/drat
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-01-07 17:30:43 UTC; jn
Author: Roger Bivand [aut] (<https://orcid.org/0000-0003-2392-6140>),
  Jakub Nowosad [aut, cre] (<https://orcid.org/0000-0002-1057-3721>),
  Robin Lovelace [aut] (<https://orcid.org/0000-0001-5679-6536>),
  Angelos Mimis [ctb],
  Mark Monmonier [ctb] (author of the state.vbm dataset),
  Greg Snow [ctb] (author of the state.vbm dataset)
Maintainer: Jakub Nowosad <nowosad.jakub@gmail.com>
Repository: CRAN
Date/Publication: 2025-01-08 12:40:02 UTC
Built: R 4.4.0; ; 2026-07-18 02:15:34 UTC; unix

Package: spData
Title: Datasets for Spatial Analysis
Version: 2.3.4
Authors@R: c(person("Roger", "Bivand", role = "aut", email="Roger.Bivand@nhh.no", comment = c(ORCID = "0000-0003-2392-6140")),
    person("Jakub", "Nowosad", role = c("aut", "cre"), email="nowosad.jakub@gmail.com", comment = c(ORCID = "0000-0002-1057-3721")),
    person("Robin", "Lovelace", role = "aut", comment = c(ORCID = "0000-0001-5679-6536")),
    person("Angelos", "Mimis", role = "ctb"),
    person("Mark", "Monmonier", role = "ctb", comment = "author of the state.vbm dataset"), 
    person("Greg", "Snow", role = "ctb", comment = "author of the state.vbm dataset")
    )
Description: Diverse spatial datasets for demonstrating, benchmarking and teaching spatial data analysis. 
    It includes R data of class sf (defined by the package 'sf'), Spatial ('sp'), and nb ('spdep').
    Unlike other spatial data packages such as 'rnaturalearth' and 'maps', 
    it also contains data stored in a range of file formats including GeoJSON and GeoPackage, but from version 2.3.4, no longer ESRI Shapefile - use GeoPackage instead. 
    Some of the datasets are designed to illustrate specific analysis techniques.
    cycle_hire() and cycle_hire_osm(), for example, is designed to illustrate point pattern analysis techniques.
Depends: R (>= 3.3.0)
Imports: sp
Suggests: foreign, sf (>= 0.9-1), spDataLarge (>= 0.4.0), spdep,
        spatialreg
License: CC0
RoxygenNote: 7.3.2
LazyData: true
URL: https://jakubnowosad.com/spData/
BugReports: https://github.com/Nowosad/spData/issues
Additional_repositories: https://jakubnowosad.com/drat
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2025-01-07 17:30:43 UTC; jn
Author: Roger Bivand [aut] (<https://orcid.org/0000-0003-2392-6140>),
  Jakub Nowosad [aut, cre] (<https://orcid.org/0000-0002-1057-3721>),
  Robin Lovelace [aut] (<https://orcid.org/0000-0001-5679-6536>),
  Angelos Mimis [ctb],
  Mark Monmonier [ctb] (author of the state.vbm dataset),
  Greg Snow [ctb] (author of the state.vbm dataset)
Maintainer: Jakub Nowosad <nowosad.jakub@gmail.com>
Repository: CRAN
Date/Publication: 2025-01-08 12:40:02 UTC
Built: R 4.4.0; ; 2026-05-13 14:14:52 UTC; unix

Package: spData
Title: Datasets for Spatial Analysis
Version: 0.3.3
Authors@R: c(person("Roger", "Bivand", role = "aut", email="Roger.Bivand@nhh.no", comment = c(ORCID = "0000-0003-2392-6140")),
    person("Jakub", "Nowosad", role = c("aut", "cre"), email="nowosad.jakub@gmail.com", comment = c(ORCID = "0000-0002-1057-3721")),
    person("Robin", "Lovelace", role = "aut", comment = c(ORCID = "0000-0001-5679-6536")),
    person("Mark", "Monmonier", role = "ctb", comment = "author of the state.vbm dataset"), 
    person("Greg", "Snow", role = "ctb", comment = "author of the state.vbm dataset")
    )
Description: Diverse spatial datasets for demonstrating, benchmarking and teaching spatial data analysis. 
    It includes R data of class sf (defined by the package 'sf'), Spatial ('sp'), and nb ('spdep').
    Unlike other spatial data packages such as 'rnaturalearth' and 'maps', 
    it also contains data stored in a range of file formats including GeoJSON, ESRI Shapefile and GeoPackage. 
    Some of the datasets are designed to illustrate specific analysis techniques.
    cycle_hire() and cycle_hire_osm(), for example, is designed to illustrate point pattern analysis techniques.
Depends: R (>= 3.3.0)
Imports: sp, raster
Suggests: foreign, maptools, rgdal, sf, spDataLarge (>= 0.3.0), spdep,
        spatialreg
License: CC0
RoxygenNote: 7.0.2
LazyData: true
URL: https://nowosad.github.io/spData/
BugReports: https://github.com/Nowosad/spData/issues
Additional_repositories: https://nowosad.github.io/drat
NeedsCompilation: no
Packaged: 2020-02-11 09:46:52 UTC; jn
Author: Roger Bivand [aut] (<https://orcid.org/0000-0003-2392-6140>),
  Jakub Nowosad [aut, cre] (<https://orcid.org/0000-0002-1057-3721>),
  Robin Lovelace [aut] (<https://orcid.org/0000-0001-5679-6536>),
  Mark Monmonier [ctb] (author of the state.vbm dataset),
  Greg Snow [ctb] (author of the state.vbm dataset)
Maintainer: Jakub Nowosad <nowosad.jakub@gmail.com>
Repository: CRAN
Date/Publication: 2020-02-11 13:00:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# spData

[![Build
Status](https://travis-ci.org/Nowosad/spData.png?branch=master)](https://travis-ci.org/Nowosad/spData)
[![CRAN
version](http://www.r-pkg.org/badges/version/spData)](https://cran.r-project.org/package=spData)
[![CRAN RStudio mirror
downloads](http://cranlogs.r-pkg.org/badges/spData)](https://cran.r-project.org/package=spData)

Datasets for spatial analysis

### **sf**

  - `alaska` - Alaska multipolygon
  - `aggregating_zones` - See `congruent`
  - `congruent` - Sample of UK administrative zones that have shared
    borders with `aggregating_zones` (`incongruent` does not have shared
    borders) for teaching the concept of spatial congruence
  - `cycle_hire` - Cycle hire points in London
  - `cycle_hire_osm` - Cycle hire points in London from OSM
  - `hawaii` - Hawaii multipolygon
  - `incongruent` - See `congruent`
  - `lnd` - The boroughs of London
  - `nz` - The regions of New Zealand
  - `nz_height` - High points in New Zealand
  - `seine` - Small river network in France
  - `urban_agglomerations` - Major urban areas worldwide
  - `us_states` - US states polygons
  - `world` - World country polygons

### **sp**

  - `auckland` - Marshall’s infant mortality in Auckland dataset
  - `elect80` - 1980 Presidential election results
  - `house` - Lucas county OH housing
  - `SplashDams` - Data for Splash Dams in western Oregon
  - `state.vbm` - US State Visibility Based Map

### **spdep**

  - `afcon` - Spatial patterns of conflict in Africa 1966-78
  - `boston` - Boston Housing Data
  - `columbus` - Columbus OH spatial analysis data set
  - `eire` - Eire data sets
  - `nc.sids` - North Carolina SIDS data
  - `NY_data` - New York leukemia data
  - `used.cars` - US 1960 used car prices

### **raster**

  - `elev` - Small raster dataset representing elevation values
  - `grain` - Small raster dataset representing grain size classes

### misc

  - `baltimore` - House sales prices, Baltimore, MD 1978
  - `coffee_data` - World coffee production statistics by country, 2016
    and 2017
  - `getisord` - Getis-Ord remote sensing example data
  - `hopkins` - Hopkins burnt savanna herb remains
  - `huddersfield` - Prevalence of respiratory symptoms
  - `jenks71` - Illinois 1959 county gross farm product value per acre
  - `us_states_df` - Selected American Community Survey (ACS) data
  - `wheat` - Mercer and Hall wheat yield data
  - `worldbank_df` - Selected World Bank data

## Installation

Get the released version from CRAN:

``` r
install.packages("spData")
```

Get the development version from github:

``` r
devtools::install_github("nowosad/spData")
```

## spDataLarge

This package interacts with data available through the **spDataLarge**
package, which is available in a ‘drat’ repository. To access this data
package,
run:

``` r
install.packages("spDataLarge", repos = "https://nowosad.github.io/drat/", type = "source")
```

The size of the **spDataLarge** package is approximately 20 MB. Learn
more about the **spDataLarge** package at
<https://github.com/Nowosad/spDataLarge>.

## Contributions

[Feel free to submit issues and enhancement
requests.](https://github.com/Nowosad/spData/issues)

This file is intended to clarify ownership and copyright: where
possible individual files also carry brief copyright notices. 

Copyrights
==========

Files: inst/shapes/baltim.*, inst/shapes/columbus.*, and inst/shapes/sids.* 
are derived by permission from SAL data files
prepared by Luc Anselin; they were downloaded from:

http://geodacenter.asu.edu/sdata

under the following conditions: "The data are provided as is, without 
any warranties. Please make sure to give proper credit when using 
them in any publications. Some of the data sets are purely illustrative 
and should not be used for substantive research."

***********************

Files: data/afcon.rda, data/columbus.rda, data/nc.sids.rda 
are derived by permission from SpaceStat data files
prepared by Luc Anselin; they were downloaded from:

http://www.spacestat.com/data.htm#data

under the following conditions: "All data sets are provided as is,
and no warranties, expressed or implied are made as to the correctness
and fitness for a purpose. Proper citation of the source of the data in
published work would be appreciated."

File: data/eire.rda is derived from data sets made available by Michael
Tiefelsdorf based on sources named in man/eire.Rd, and downloaded from:

http://geog-www.sbs.ohio-state.edu/faculty/tiefelsdorf/GeoStat.htm

File: data/auckland.rda is derived from data sets included with INFOMAP 
in Bailey T, Gatrell A (1995) Interactive Spatial Data Analysis, Harlow: 
Longman, and is used with permission of the authors.

File: data/NY_data.rda  is derived from data sets for Waller, L. and
C. Gotway (2004) Applied Spatial Statistics for Public Health Data,
New York: John Wiley and Sons, and is used with permission of the authors.

Other files in the data directory are derived from sources given on
their help pages.

<!-- README.md is generated from README.Rmd. Please edit that file -->

# spData <img src="man/figures/logo.png" align="right" alt="" width="150" />

[![GitHub action build
status](https://github.com/Nowosad/spData/workflows/pkgdown/badge.svg)](https://github.com/Nowosad/spData/actions)
[![CRAN
version](https://www.r-pkg.org/badges/version/spData)](https://cran.r-project.org/package=spData)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/spData)](https://cran.r-project.org/package=spData)
[![CRAN RStudio total mirror
downloads](https://cranlogs.r-pkg.org/badges/grand-total/spData)](https://cran.r-project.org/package=spData)

Datasets for spatial analysis (from version 2.3.4, ESRI Shapefile
datasets have been dropped, use the provided GeoPackage files instead)

### **sf**

- `alaska` - Alaska multipolygon
- `aggregating_zones` - See `congruent`
- `congruent` - Sample of UK administrative zones that have shared
  borders with `aggregating_zones` (`incongruent` does not have shared
  borders) for teaching the concept of spatial congruence
- `cycle_hire` - Cycle hire points in London
- `cycle_hire_osm` - Cycle hire points in London from OSM
- `hawaii` - Hawaii multipolygon
- `incongruent` - See `congruent`
- `lnd` - The boroughs of London
- `nz` - The regions of New Zealand
- `nz_height` - High points in New Zealand
- `seine` - Small river network in France
- `urban_agglomerations` - Major urban areas worldwide
- `us_states` - US states polygons
- `world` - World country polygons

### **sp**

- `auckland` - Marshall’s infant mortality in Auckland dataset
- `elect80` - 1980 Presidential election results
- `house` - Lucas county OH housing
- `SplashDams` - Data for Splash Dams in western Oregon
- `state.vbm` - US State Visibility Based Map

### **spdep**

- `afcon` - Spatial patterns of conflict in Africa 1966-78
- `boston` - Boston Housing Data
- `columbus` - Columbus OH spatial analysis data set
- `eire` - Eire data sets
- `nc.sids` - North Carolina SIDS data
- `NY_data` - New York leukemia data
- `used.cars` - US 1960 used car prices

### **raster**

- `elev.tif` - Small raster dataset representing elevation values
- `grain.tif` - Small raster dataset representing grain size classes

### misc

- `baltimore` - House sales prices, Baltimore, MD 1978
- `coffee_data` - World coffee production statistics by country, 2016
  and 2017
- `getisord` - Getis-Ord remote sensing example data
- `hopkins` - Hopkins burnt savanna herb remains
- `huddersfield` - Prevalence of respiratory symptoms
- `jenks71` - Illinois 1959 county gross farm product value per acre
- `us_states_df` - Selected American Community Survey (ACS) data
- `wheat` - Mercer and Hall wheat yield data
- `worldbank_df` - Selected World Bank data
- `depmunic` and `properties` - Athens properties data set from **HSAR**

## Installation

Get the released version from CRAN:

``` r
install.packages("spData")
```

Get the development version from github:

``` r
devtools::install_github("nowosad/spData")
```

## spDataLarge

This package interacts with data available through the **spDataLarge**
package, which is available in a ‘drat’ repository. To access this data
package, run:

``` r
install.packages("spDataLarge", repos = "https://nowosad.github.io/drat/", type = "source")
```

The size of the **spDataLarge** package is approximately 20 MB. Learn
more about the **spDataLarge** package at
<https://github.com/Nowosad/spDataLarge>.

## Contributions

[Feel free to submit issues and enhancement
requests.](https://github.com/Nowosad/spData/issues)

#' @name coffee_data
#' @title World coffee production data
#'
#' @description A tiny dataset containing estimates of global coffee in thousands of 60 kg bags produced by country.
#' Purpose: teaching **not** research.
#' 
#' @format A data frame (tibble) with 58 for the following 12 variables:
#' \itemize{
#' \item{name_long} {name of country or coffee variety}
#' \item{coffee_production_2016} {production in 2016}
#' \item{coffee_production_2017} {production in 2017}
#' }
#' 
#' @details The examples section shows how this can be joined with spatial data to create a simple map.
#' @source The International Coffee Organization (ICO). See http://www.ico.org/ and
#' http://www.ico.org/prices/m1-exports.pdf
#' @docType data
#' @keywords datasets misc
#' @examples 
#' head(coffee_data)
#' \dontrun{
#' library(tidyverse)
#' library(sf)
#' # found by searching for "global coffee data"
#' u = "http://www.ico.org/prices/m1-exports.pdf"
#' download.file(u, "data.pdf", mode = "wb")
#' install.packages("pdftables") # requires api key
#' pdftables::convert_pdf(input_file = "data.pdf", output_file = "coffee-data-messy.csv")
#' d = read_csv("coffee-data-messy.csv")
#' file.remove("coffee-data-messy.csv")
#' file.remove("data.pdf")
#' coffee_data = slice(d, -c(1:9)) %>% 
#'         select(name_long = 1, coffee_production_2016 = 2, coffee_production_2017 = 3) %>% 
#'         filter(!is.na(coffee_production_2016)) %>% 
#'         mutate_at(2:3, str_replace, " ", "") %>% 
#'         mutate_at(2:3, as.integer)
#' world_coffee = left_join(world, coffee_data)
#' plot(world_coffee[c("coffee_production_2016", "coffee_production_2017")])
#' b = c(0, 500, 1000, 2000, 3000)
#' library(tmap)
#' tm_shape(world_coffee) +
#'   tm_fill("coffee_production_2017", title = "Thousand 60kg bags", breaks = b,
#'           textNA = "No data", colorNA = NULL)
#' tmap_mode("view") # for an interactive version
#' }
"coffee_data"

#' @name boston
#' @aliases boston boston.c boston.soi boston.utm
#' @title Corrected Boston Housing Data
#'
#' @description The \code{boston.c} data frame has 506 rows and 20 columns. It contains the Harrison and Rubinfeld (1978) data corrected for a few minor errors and augmented with the latitude and longitude of the observations. Gilley and Pace also point out that MEDV is censored, in that median values at or over USD 50,000 are set to USD 50,000. The original data set without the corrections is also included in package \code{mlbench} as \code{BostonHousing}. In addition, a matrix of tract point coordinates projected to UTM zone 19 is included as \code{boston.utm}, and a sphere of influence neighbours list as \code{boston.soi}.
#' 
#' @format   This data frame contains the following columns:
#' \itemize{
#'         \item{TOWN} {a factor with levels given by town names}
#'         \item{TOWNNO} {a numeric vector corresponding to TOWN}
#'         \item{TRACT} {a numeric vector of tract ID numbers}
#'         \item{LON} {a numeric vector of tract point longitudes in decimal degrees}
#'         \item{LAT} {a numeric vector of tract point latitudes in decimal degrees}
#'         \item{MEDV} {a numeric vector of median values of owner-occupied housing
#'                 in USD 1000}
#'         \item{CMEDV} {a numeric vector of corrected median values of
#'                 owner-occupied housing in USD 1000}
#'         \item{CRIM} {a numeric vector of per capita crime}
#'         \item{ZN} {a numeric vector of proportions of residential land zoned
#'                 for lots over 25000 sq. ft per town (constant for all Boston tracts)}
#'         \item{INDUS} {a numeric vector of proportions of non-retail business
#'                 acres per town (constant for all Boston tracts)}
#'         \item{CHAS} {a factor with levels 1 if tract borders Charles River;
#'                 0 otherwise}
#'         \item{NOX} {a numeric vector of nitric oxides concentration (parts per
#'                                                                     10 million) per town}
#'         \item{RM} {a numeric vector of average numbers of rooms per dwelling}
#'         \item{AGE} {a numeric vector of proportions of owner-occupied units
#'                 built prior to 1940}
#'         \item{DIS} {a numeric vector of weighted distances to five Boston
#'                 employment centres}
#'         \item{RAD} {a numeric vector of an index of accessibility to radial
#'                 highways per town (constant for all Boston tracts)}
#'         \item{TAX} {a numeric vector full-value property-tax rate per USD
#'                 10,000 per town (constant for all Boston tracts)}
#'         \item{PTRATIO} {a numeric vector of pupil-teacher ratios per town
#'                 (constant for all Boston tracts)}
#'         \item{B} {a numeric vector of \code{1000*(Bk - 0.63)^2} where Bk is the
#'                 proportion of blacks}
#'         \item{LSTAT} {a numeric vector of percentage values of lower status
#'                 population}
#' }
#' @note Details of the creation of the tract shapefile given in final don't run block; tract boundaries for 1990: http://www.census.gov/geo/cob/bdy/tr/tr90shp/tr25_d90_shp.zip, counties in the BOSTON SMSA http://www.census.gov/population/metro/files/lists/historical/63mfips.txt; tract conversion table 1980/1970: \url{https://www.icpsr.umich.edu/icpsrweb/ICPSR/studies/7913?q=07913&permit[0]=AVAILABLE}, \url{http://www.icpsr.umich.edu/cgi-bin/bob/zipcart2?path=ICPSR&study=7913&bundle=all&ds=1&dups=yes}. The shapefile contains corrections and extra variables (tract 3592 is corrected to 3593; the extra columns are:
#'  \itemize{
#'    \item{units}{number of single family houses}
#'    \item{cu5k}{count of units under USD 5,000}
#'    \item{c5_7_5}{counts USD 5,000 to 7,500}
#'    \item{C*_*}{interval counts}
#'    \item{co50k}{count of units over USD 50,000}
#'    \item{median}{recomputed median values}
#'    \item{BB}{recomputed black population proportion}
#'    \item{censored}{whether censored or not}
#'    \item{NOXID}{NOX model zone ID}
#'    \item{POP}{tract population}
#'  }
#' 
#' @source \url{http://lib.stat.cmu.edu/datasets/boston_corrected.txt}
#' @references 
#' Harrison, David, and Daniel L. Rubinfeld, Hedonic Housing Prices and the Demand for Clean Air, \emph{Journal of Environmental Economics and Management}, Volume 5, (1978), 81-102. Original data.
#' 
#' Gilley, O.W., and R. Kelley Pace, On the Harrison and Rubinfeld Data, \emph{Journal of Environmental Economics and Management}, 31 (1996),403-405. Provided corrections and examined censoring.
#' 
#' Pace, R. Kelley, and O.W. Gilley, Using the Spatial Configuration of the Data to Improve Estimation,  \emph{Journal of the Real Estate Finance and Economics}, 14 (1997), 333-340.
#'
#' Bivand, Roger. Revisiting the Boston data set - Changing the units of observation affects estimated willingness to pay for clean air. REGION, v. 4, n. 1, p. 109-127, 2017. \url{http://openjournals.wu.ac.at/ojs/index.php/region/article/view/107}. 
#' 
#' @docType data
#' @keywords datasets spdep
#' 
#' @examples 
#' if (requireNamespace("spdep", quietly = TRUE)) {
#'   library(spdep)
#'   data(boston)
#'   hr0 <- lm(log(MEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2) +
#'                     AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT), data = boston.c)
#'   summary(hr0)
#'   logLik(hr0)
#'   gp0 <- lm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2) +
#'                     AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT), data = boston.c)
#'   summary(gp0)
#'   logLik(gp0)
#'   lm.morantest(hr0, nb2listw(boston.soi))
#' }
#' \dontrun{
#' library(rgdal)
#' boston.tr <- readOGR(system.file("shapes/boston_tracts.shp",
#'                            package="spData")[1])
#' boston_nb <- poly2nb(boston.tr)
#' }
#' \dontrun{
#' if (requireNamespace("spatialreg", quietly = TRUE)) {
#'   library(spatialreg)
#'   gp1 <- errorsarlm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2)
#'                              + I(RM^2) +  AGE + log(DIS) + log(RAD) +
#'                               TAX + PTRATIO + B + log(LSTAT),
#'                              data=boston.c, nb2listw(boston.soi), method="Matrix", 
#'                              control=list(tol.opt = .Machine$double.eps^(1/4)))
#'   summary(gp1)
#'   gp2 <- lagsarlm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2)
#'                   +  AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT),
#'                   data=boston.c, nb2listw(boston.soi), method="Matrix")
#'   summary(gp2)
#' }
#' }
#' 
NULL

#' @name jenks71
#' @aliases jenks71
#' @title Illinois 1959 county gross farm product value per acre
#'
#' @description Classic data set for the choice of class intervals for choropleth maps.
#' 
#' @format A data frame with 102 observations on the following 2 variables.
#' \itemize{
#'         \item{\code{jenks71}} {a numeric vector: Per acre value of gross farm products in dollars by county for Illinois in #' 1959}
#'         \item{\code{area}} {a numeric vector: county area in square miles}
#' }
#' 
#' @source Jenks, G. F., Caspall, F. C., 1971. "Error on choroplethic maps: definition, measurement, reduction". Annals, Association of American Geographers, 61 (2), 217--244
#' @docType data
#' @keywords datasets misc
#' 
#' @examples 
#' data(jenks71)
#' jenks71
"jenks71"

#' @name nydata
#' @aliases NY_data nydata listw_NY
#' @title New York leukemia data
#'
#' @description New York leukemia data taken from the data sets supporting Waller and Gotway 2004 (the data should be loaded by running \code{example(NY_data)} to demonstrate spatial data import techniques)
#' 
#' @format A data frame with 281 observations on the following 12 variables, and the binary coded spatial weights used in the source.
#' \itemize{
#' \item{AREANAME: name of census tract}
#' \item{AREAKEY: unique FIPS code for each tract}
#' \item{X: x-coordinate of tract centroid (in km)}
#' \item{Y: y-coordinate of tract centroid (in km)}
#' \item{POP8: population size (1980 U.S. Census)}
#' \item{TRACTCAS: number of cases 1978-1982}
#' \item{PROPCAS: proportion of cases per tract}
#' \item{PCTOWNHOME: percentage of people in each tract owning their own home}
#' \item{PCTAGE65P: percentage of people in each tract aged 65 or more}
#' \item{Z: ransformed propoprtions}
#' \item{AVGIDIST: average distance between centroid and TCE sites}
#' \item{PEXPOSURE: "exposure potential": inverse distance between each census tract centroid and the nearest TCE site, IDIST, transformed via log(100*IDIST)}
#' \item{Cases: as TRACTCAS with more digits}
#' \item{Xm: X in metres}
#' \item{Ym: Y in metres}
#' \item{Xshift: feature offset}
#' \item{Yshift: feature offset}
#' }
#' 
#' @details The examples section shows how the DBF files from the book website for Chapter 9 were converted into the \code{nydata} data frame and the \code{listw_NY} spatial weights list. The \code{shapes} directory includes the original version of the UTM18 census tract boundaries imported from BNA format (http://sedac.ciesin.columbia.edu/ftpsite/pub/census/usa/tiger/ny/bna_st/t8_36.zip) before the OGR/GDAL BNA driver was available. The \code{NY8_utm18} shapefile was constructed using a bna2mif converter and converted to shapefile format after adding data using \code{writeOGR}. The new file \code{NY8_bna_utm18.gpkg} has been constructed from the original BNA file, but read using the OGR BNA driver with GEOS support. The NY8 shapefile and GeoPackage NY8_utm18.gpkg include invalid polygons, but because the OGR BNA driver may have GEOS support (used here), the tract polygon objects in NY8_bna_utm18.gpkg are valid.
#' 
#' @source http://www.sph.emory.edu/~lwaller/ch9index.htm
#' @references Waller, L. and C. Gotway (2004) \emph{Applied Spatial Statistics for Public Health Data}. New York: John Wiley and Sons.
#' @docType data
#' @keywords datasets foreign spdep
#' 
#' @examples 
#' ## NY leukemia
#' \donttest{
#' if (requireNamespace("sf", quietly = TRUE)) {
#' library(foreign)
#' nydata <- read.dbf(system.file("misc/nydata.dbf", package="spData")[1])
#' nydata <- sf::st_as_sf(nydata, coords=c("X", "Y"), remove=FALSE)
#' plot(sf::st_geometry(nydata))
#' 
#' nyadjmat <- as.matrix(read.dbf(system.file("misc/nyadjwts.dbf",
#'                                            package="spData")[1])[-1])
#' ID <- as.character(names(read.dbf(system.file("misc/nyadjwts.dbf",
#'                                               package="spData")[1]))[-1])
#' identical(substring(ID, 2, 10), substring(as.character(nydata$AREAKEY), 2, 10))
#' 
#' if (requireNamespace("sf", quietly = TRUE)) {
#' library(spdep)
#' listw_NY <- mat2listw(nyadjmat, as.character(nydata$AREAKEY), style="B")
#' }
#' }
#' }
"nydata"

#' @name SplashDams
#' @aliases SplashDams
#' @title Data for Splash Dams in western Oregon
#'
#' @description Data for Splash Dams in western Oregon
#' 
#' @format Formal class 'SpatialPointsDataFrame with 232 obs. of  6 variables:
#' \itemize{
#' \item{streamName} {}
#' \item{locationCode} {}
#' \item{height} {}
#' \item{lastDate} {}
#' \item{owner} {}
#' \item{datesUsed} {}
#' }
#' 
#' @source R. R. Miller (2010) Is the Past Present? Historical Splash-dam Mapping and Stream Disturbance Detection in the Oregon Coastal Province. MSc. thesis, Oregon State University; packaged by Jonathan Callahan
#' @references \url{http://www.fs.fed.us/pnw/lwm/aem/docs/burnett/miller_rebecca_r2010rev.pdf}
#' @docType data
#' @keywords datasets sp
#' @importClassesFrom sp SpatialPointsDataFrame
#' 
#' @examples 
#' if (requireNamespace("sp", quietly = TRUE)) {
#'   library(sp)
#'   data(SplashDams)
#'   plot(SplashDams, axes=TRUE)
#' }
"SplashDams"

.pkgenv <- new.env(parent = emptyenv())

.onLoad  <- function(libname, pkgname) {
        has_data <- requireNamespace("spDataLarge", quietly = TRUE)
        .pkgenv[["has_data"]] <- has_data
        # repos = getOption("repos")
        # repos["nowosaddrat"] = "https://nowosad.github.io/drat/"
        # options(repos = repos)
        # invisible(repos)
}

.onAttach <- function(libname, pkgname) {
        if (!.pkgenv$has_data) {
                msg <- paste("To access larger datasets in this package, install the",
                             "spDataLarge package with:\n",
                             "`install.packages('spDataLarge',", 
                             "repos='https://nowosad.github.io/drat/', type='source')`")
                msg <- paste(strwrap(msg), collapse="\n")
                packageStartupMessage(msg)
        }
}

hasData <- function(has_data = .pkgenv$has_data) {
        if (!has_data) {
                msg <- paste("To use this function, you must have the",
                             "`spDataLarge` package installed.")
                msg <- paste(strwrap(msg), collapse="\n")
                stop(msg)
        }
}

#' @name cycle_hire_osm
#' @aliases cycle_hire_osm
#' @title Cycle hire points in London from OSM
#'
#' @description Dataset downloaded using the osmdata package
#' representing cycle hire points accross London.
#' 
#' @format 
#' \itemize{
#'     \item{osm_id} {The OSM ID}
#'     \item{name} {The name of the cycle point}
#'     \item{capacity} {How many bikes it can take}
#'     \item{cyclestreets_id} {The ID linked to cyclestreets' photomap}
#'     \item{description} {Additional description of points}
#'     \item{geometry} {sfc_POINT}
#' }
#' 
#' @seealso 
#' See the osmdata package: https://cran.r-project.org/package=osmdata
#' 
#' @source \url{http://www.openstreetmap.org}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(cycle_hire_osm)
#'   # or
#'   cycle_hire_osm <- st_read(system.file("shapes/cycle_hire_osm.geojson", package="spData"))
#'   
#'   plot(cycle_hire_osm)
#' }
#' 
#' # Code used to download the data:
#' \dontrun{
#' library(osmdata)
#' library(dplyr)
#' library(sf)
#' q = add_osm_feature(opq = opq("London"), key = "network", value = "tfl_cycle_hire")
#' lnd_cycle_hire = osmdata_sf(q)
#' cycle_hire_osm = lnd_cycle_hire$osm_points
#' nrow(cycle_hire_osm)
#' plot(cycle_hire_osm)
#' cycle_hire_osm = dplyr::select(cycle_hire_osm, osm_id, name, capacity, 
#'                                cyclestreets_id, description) %>%
#'   mutate(capacity = as.numeric(capacity))
#' names(cycle_hire_osm)
#' nrow(cycle_hire_osm)
#' }
"cycle_hire_osm"

#' @name huddersfield
#' @aliases huddersfield
#' @title Prevalence of respiratory symptoms
#'
#' @description Prevalence of respiratory symptoms in 71 school catchment areas in Huddersfield, Northern England
#' 
#' @format A data frame with 71 observations on the following 2 variables.
#' \itemize{
#'         \item{\code{cases}} {Prevalence of at least mild conditions}
#'         \item{\code{total}} {Number of questionnaires returned}
#' }
#' 
#' @source Martuzzi M, Elliott P (1996) Empirical Bayes estimation of small area prevalence of non-rare conditions, Statistics in Medicine 15, 1867--1873, pp. 1870--1871.
#' @docType data
#' @keywords datasets misc
#' 
#' @examples 
#' data(huddersfield)
#' str(huddersfield)
"huddersfield"

#' @name nc.sids
#' @aliases nc.sids ncCR85.nb ncCC89.nb sidspolys sidscents
#' @title North Carolina SIDS data
#'
#' @description (Use \code{example(nc.sids)} to read the data set from shapefile, together with import of two different list of neighbours). 
#' The \code{nc.sids} data frame has 100 rows and 21 columns. It contains data given in Cressie (1991, pp. 386-9), Cressie and Read (1985) and Cressie and Chan (1989) on sudden infant deaths in North Carolina for 1974-78 and 1979-84. The data set also contains the neighbour list given by Cressie and Chan (1989) omitting self-neighbours (ncCC89.nb), and the neighbour list given by Cressie and Read (1985) for contiguities (ncCR85.nb). The data are ordered by county ID number, not alphabetically as in the source tables \code{sidspolys} is a "polylist" object of polygon boundaries, and \code{sidscents} is a matrix of their centroids.
#' 
#' @format 
#' This data frame contains the following columns:
#' \itemize{
#'         \item{SP_ID} {SpatialPolygons ID}
#'         \item{CNTY_ID} {county ID}
#'         \item{east} {eastings, county seat, miles, local projection}
#'         \item{north} {northings, county seat, miles, local projection}
#'         \item{L_id} {Cressie and Read (1985) L index}
#'         \item{M_id} {Cressie and Read (1985) M index}
#'         \item{names} {County names}
#'         \item{AREA} {County polygon areas in degree units}
#'         \item{PERIMETER} {County polygon perimeters in degree units}
#'         \item{CNTY_} {Internal county ID}
#'         \item{NAME} {County names}
#'         \item{FIPS} {County ID}
#'         \item{FIPSNO} {County ID}
#'         \item{CRESS_ID} {Cressie papers ID}
#'         \item{BIR74} {births, 1974-78}
#'         \item{SID74} {SID deaths, 1974-78}
#'         \item{NWBIR74} {non-white births, 1974-78}
#'         \item{BIR79} {births, 1979-84}
#'         \item{SID79} {SID deaths, 1979-84}
#'         \item{NWBIR79} {non-white births, 1979-84}
#' }
#' 
#' @source Cressie, N (1991), \emph{Statistics for spatial data}. New York: Wiley, pp. 386--389; Cressie, N, Chan NH (1989) Spatial modelling of regional variables. \emph{Journal of the American Statistical Association}, 84, 393--401; Cressie, N, Read, TRC (1985) Do sudden infant deaths come in clusters? \emph{Statistics and Decisions} Supplement Issue 2, 333--349; http://sal.agecon.uiuc.edu/datasets/sids.zip.
#' @docType data
#' @keywords datasets spdep
#' 
#' @examples 
#' if (requireNamespace("rgdal", quietly = TRUE)) {
#'   library(rgdal)
#'   if (requireNamespace("spdep", quietly = TRUE)) {
#'     library(spdep)
#'     nc.sids <- readOGR(system.file("shapes/sids.shp", package="spData")[1])
#'     proj4string(nc.sids) <- CRS("+proj=longlat +ellps=clrk66")
#'     row.names(nc.sids) <- as.character(nc.sids$FIPS)
#'     rn <- row.names(nc.sids)
#'     ncCC89_nb <- read.gal(system.file("weights/ncCC89.gal", package="spData")[1],
#'                           region.id=rn)
#'     ncCR85_nb <- read.gal(system.file("weights/ncCR85.gal", package="spData")[1],
#'                           region.id=rn)
#'                           
#'     plot(nc.sids, border="grey")
#'     plot(ncCR85_nb, coordinates(nc.sids), add=TRUE, col="blue")
#'     plot(nc.sids, border="grey")
#'     plot(ncCC89_nb, coordinates(nc.sids), add=TRUE, col="blue")
#'   }
#' }
"nc.sids"

#' @name baltimore
#' @aliases baltimore
#' @title House sales prices, Baltimore, MD 1978
#'
#' @description House sales price and characteristics for a spatial hedonic regression, Baltimore, MD 1978. X,Y on Maryland grid, projection type unknown.
#' 
#' @format A data frame with 211 observations on the following 17 variables.
#' \itemize{
#'         \item{STATION: a numeric vector}
#'         \item{PRICE: a numeric vector}
#'         \item{NROOM: a numeric vector}
#'         \item{DWELL: a numeric vector}
#'         \item{NBATH: a numeric vector}
#'         \item{PATIO: a numeric vector}
#'         \item{FIREPL: a numeric vector}
#'         \item{AC: a numeric vector}
#'         \item{BMENT: a numeric vector}
#'         \item{NSTOR: a numeric vector}
#'         \item{GAR: a numeric vector}
#'         \item{AGE: a numeric vector}
#'         \item{CITCOU: a numeric vector}
#'         \item{LOTSZ: a numeric vector}
#'         \item{SQFT: a numeric vector}
#'         \item{X: a numeric vector}
#'         \item{Y: a numeric vector}
#' }
#' 
#' @source Prepared by Luc Anselin. Original data made available by Robin Dubin, Weatherhead School of Management, Case Western Research University, Cleveland, OH. http://sal.agecon.uiuc.edu/datasets/baltimore.zip
#' @references Dubin, Robin A. (1992). Spatial autocorrelation and neighborhood quality. Regional Science and Urban Economics 22(3), 433-452.
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' data(baltimore)
#' str(baltimore)
#' 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   baltimore_sf <- baltimore |> st_as_sf(coords = c("X","Y"))
#'   plot(baltimore_sf["PRICE"])
#' }
"baltimore"

#' @name used.cars
#' @aliases used.cars usa48.nb
#' @title US 1960 used car prices
#'
#' @description The \code{used.cars} data frame has 48 rows and 2 columns. The data set includes a neighbours list for the 48 states excluding DC from poly2nb().
#' 
#' @format This data frame contains the following columns:
#' \itemize{
#' \item{tax.charges} {taxes and delivery charges for 1955-9 new cars}
#' \item{price.1960} {1960 used car prices by state}
#' }
#' 
#' @source Hanna, F. A. 1966 Effects of regional differences in taxes and transport charges on automobile consumption, in Ostry, S., Rhymes, J. K. (eds) Papers on regional statistical studies, Toronto: Toronto University Press, pp. 199-223.
#' @references Hepple, L. W. 1976 A maximum likelihood model for econometric estimation with spatial series, in Masser, I (ed) Theory and practice in regional science, London: Pion, pp. 90-104.
#' @docType data
#' @keywords datasets spdep
#' 
#' @examples 
#' if (requireNamespace("spdep", quietly = TRUE)) {
#'   library(spdep)
#'   data(used.cars)
#'   moran.test(used.cars$price.1960, nb2listw(usa48.nb))
#'   moran.plot(used.cars$price.1960, nb2listw(usa48.nb),
#'            labels=rownames(used.cars))
#'   uc.lm <- lm(price.1960 ~ tax.charges, data=used.cars)
#'   summary(uc.lm)
#' 
#'   lm.morantest(uc.lm, nb2listw(usa48.nb))
#'   lm.morantest.sad(uc.lm, nb2listw(usa48.nb))
#'   lm.LMtests(uc.lm, nb2listw(usa48.nb))
#'   if (requireNamespace("spatialreg", quietly = TRUE)) {
#'     library(spatialreg)
#'     uc.err <- errorsarlm(price.1960 ~ tax.charges, data=used.cars,
#'                        nb2listw(usa48.nb), tol.solve=1.0e-13, 
#'                        control=list(tol.opt=.Machine$double.eps^0.3))
#'     summary(uc.err)
#'     uc.lag <- lagsarlm(price.1960 ~ tax.charges, data=used.cars,
#'                      nb2listw(usa48.nb), tol.solve=1.0e-13, 
#'                      control=list(tol.opt=.Machine$double.eps^0.3))
#'     summary(uc.lag)
#'     uc.lag1 <- lagsarlm(price.1960 ~ 1, data=used.cars,
#'                       nb2listw(usa48.nb), tol.solve=1.0e-13, 
#'                       control=list(tol.opt=.Machine$double.eps^0.3))
#'     summary(uc.lag1)
#'     uc.err1 <- errorsarlm(price.1960 ~ 1, data=used.cars,
#'                         nb2listw(usa48.nb), tol.solve=1.0e-13, 
#'                         control=list(tol.opt=.Machine$double.eps^0.3))
#'     summary(uc.err1)
#'   }
#' }
"used.cars"

#' @name world
#' @aliases wrld
#' @title World country polygons
#'
#' @description The object loaded is a \code{sf} object containing a world map data from Natural Earth with a few variables from World Bank
#' 
#' @format Formal class 'sf' [package "sf"]; the data contains a data.frame with 177 obs. of 11 variables:
#' \itemize{
#'     \item{iso_a2} {character vector of ISO 2 character country codes}
#'     \item{name_long} {character vector of country names}
#'     \item{continent} {character vector of continent names}
#'     \item{region_un} {character vector of region names}
#'     \item{subregion} {character vector of subregion names}
#'     \item{type} {character vector of type names}
#'     \item{area_km2} {integer vector of area values}
#'     \item{pop} {integer vector of population in 2014}
#'     \item{lifeExp} {integer vector of life expectancy at birth in 2014}
#'     \item{gdpPercap} {integer vector of per-capita GDP in 2014}
#'     \item{geom} {sfc_MULTIPOLYGON}
#' }
#' The object is in geographical coordinates using the WGS84 datum.
#' 
#' @seealso 
#' See the rnaturalearth package: https://cran.r-project.org/package=rnaturalearth
#' 
#' @source \url{http://www.naturalearthdata.com/}
#' @source \url{http://data.worldbank.org/}
#' @docType data
#' @keywords datasets sf
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(world)
#'   # or
#'   world <- st_read(system.file("shapes/world.gpkg", package="spData"))
#' 
#'   plot(world)
#' }
"world"

#' @name urban_agglomerations
#' @aliases urban_agglomerations
#' @title Major urban areas worldwide
#'
#' @description Dataset in a 'long' form from the United Nations
#' population division with projections up to 2050.
#' Includes only the top 30 largest areas by population at 5 year intervals.
#' 
#' @format 
#' Selected variables:
#' \itemize{
#'     \item{year} {Year of population estimate}
#'     \item{country_code} {Code of country}
#'     \item{urban_agglomeration} {Name of the urban agglomeration}
#'     \item{population_millions} {Estimated human population}
#'     \item{geometry} {sfc_POINT}
#' }
#' 
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   plot(urban_agglomerations)
#' }
#' # Code used to download the data:
#' \dontrun{
#' f = "WUP2018-F11b-30_Largest_Cities_in_2018_by_time.xls"
#' download.file(
#'   destfile = f,
#'   url = paste0("https://population.un.org/wup/Download/Files/", f)
#'  )
#' library(dplyr)
#' library(sf)
#' urban_agglomerations = readxl::read_excel(f, skip = 16) %>%
#'     st_as_sf(coords = c("Longitude", "Latitude"), crs = 4326)
#' names(urban_agglomerations)
#' names(urban_agglomerations) <- gsub(" |\\n", "_", tolower(names(urban_agglomerations)) ) %>% 
#'         gsub("\\(|\\)", "", .)
#' names(urban_agglomerations)
#' urban_agglomerations
#' usethis::use_data(urban_agglomerations, overwrite = TRUE)
#' file.remove("WUP2018-F11b-30_Largest_Cities_in_2018_by_time.xls")
#' }
"urban_agglomerations"

#' @name us_states_df
#' @title the American Community Survey (ACS) data
#'
#' @description The object loaded is a \code{data.frame} object containing the US states data from the American Community Survey (ACS)
#' 
#' @format Formal class 'data.frame'; the data contains a data.frame with 51 obs. of 5 variables:
#' \itemize{
#'     \item{state} {character vector of state names}
#'     \item{median_income_10} {numerical vector of median income in 2010}
#'     \item{median_income_15} {numerical vector of median income in 2010}
#'     \item{poverty_level_10} {numerical vector of number of people with income below poverty level in 2010}
#'     \item{poverty_level_15} {numerical vector of number of people with income below poverty level in 2015}
#' }
#' 
#' @seealso 
#' See the tidycensus package: https://cran.r-project.org/package=tidycensus
#' 
#' @source \url{https://www.census.gov/programs-surveys/acs/}
#' @docType data
#' @keywords datasets
#' @examples 
#' data(us_states_df)
#' 
#' summary(us_states_df)
#' 
"us_states_df"

#' @name eire
#' @aliases eire eire.df eire.polys.utm eire.coords.utm eire.nb
#' @title Eire data sets
#'
#' @description The Eire data set has been converted to shapefile format and placed in the etc/shapes directory. The initial data objects are now stored as a SpatialPolygonsDataFrame object, from which the contiguity neighbour list is recreated. For purposes of record, the original data set is retained. 
#' The \code{eire.df} data frame has 26 rows and 9 columns. In addition, polygons of the 26 counties are provided as a multipart polylist in eire.polys.utm (coordinates in km, projection UTM zone 30). Their centroids are in eire.coords.utm. The original Cliff and Ord binary contiguities are in eire.nb.
#' 
#' @format This data frame contains the following columns:
#' \itemize{
#'         \item{A} {Percentage of sample with blood group A}
#'         \item{towns} {Towns/unit area}
#'         \item{pale} {Beyond the Pale 0, within the Pale 1}
#'         \item{size} {number of blood type samples}
#'         \item{ROADACC} {arterial road network accessibility in 1961}
#'         \item{OWNCONS} {percentage in value terms of gross agricultural output of each county consumed by itself}
#'         \item{POPCHG} {1961 population as percentage of 1926}
#'         \item{RETSALE} {value of retail sales British Pound000}
#'         \item{INCOME} {total personal income British Pound000}
#'         \item{names} {County names}
#' }
#' 
#' @source Upton and Fingleton 1985, - Bailey and Gatrell 1995, ch. 1 for blood group data, Cliff and Ord (1973), p. 107 for remaining variables (also after O'Sullivan, 1968). Polygon borders and Irish data sourced from Michael Tiefelsdorf's SPSS Saddlepoint bundle, originally hosted at: http://geog-www.sbs.ohio-state.edu/faculty/tiefelsdorf/GeoStat.htm.
#' @docType data
#' @keywords datasets sp spdep
#' 
#' @examples 
#' \dontrun{
#' library(maptools)
#' library(rgdal)
#' library(spdep)
#' eire <- readOGR(system.file("shapes/eire.shp", package="spData")[1])
#' eire.nb <- poly2nb(eire)
#' 
#' data(eire)
#' # Eire physical anthropology blood group data
#' summary(eire$A)
#' brks <- round(fivenum(eire$A), digits=2)
#' cols <- rev(heat.colors(4))
#' plot(eire, col=cols[findInterval(eire$A, brks, all.inside=TRUE)])
#' title(main="Percentage with blood group A in Eire")
#' legend(x=c(-50, 70), y=c(6120, 6050), leglabs(brks), fill=cols, bty="n")
#' 
#' plot(eire)
#' plot(eire.nb, coordinates(eire), add=TRUE)
#' 
#' lA <- lag.listw(nb2listw(eire.nb), eire$A)
#' summary(lA)
#' moran.test(eire$A, nb2listw(eire.nb))
#' geary.test(eire$A, nb2listw(eire.nb))
#' cor(lA, eire$A)
#' moran.plot(eire$A, nb2listw(eire.nb), labels=eire$names)
#' A.lm <- lm(A ~ towns + pale, data=eire)
#' summary(A.lm)
#' res <- residuals(A.lm)
#' brks <- c(min(res),-2,-1,0,1,2,max(res))
#' cols <- rev(cm.colors(6))
#' 
#' plot(eire, col=cols[findInterval(res, brks, all.inside=TRUE)])
#' title(main="Regression residuals")
#' legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cols, bty="n")
#' 
#' lm.morantest(A.lm, nb2listw(eire.nb))
#' lm.morantest.sad(A.lm, nb2listw(eire.nb))
#' lm.LMtests(A.lm, nb2listw(eire.nb), test="LMerr")
#' 
#' # Eire agricultural data
#' brks <- round(fivenum(eire$OWNCONS), digits=2)
#' cols <- grey(4:1/5)
#' plot(eire, col=cols[findInterval(eire$OWNCONS, brks, all.inside=TRUE)])
#' title(main="Percentage own consumption of agricultural produce")
#' legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cols, bty="n")
#' 
#' moran.plot(eire$OWNCONS, nb2listw(eire.nb))
#' moran.test(eire$OWNCONS, nb2listw(eire.nb))
#' e.lm <- lm(OWNCONS ~ ROADACC, data=eire)
#' res <- residuals(e.lm)
#' brks <- c(min(res),-2,-1,0,1,2,max(res))
#' cols <- rev(cm.colors(6))
#' plot(eire, col=cols[findInterval(res, brks, all.inside=TRUE)])
#' title(main="Regression residuals")
#' legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cm.colors(6), bty="n")
#' 
#' lm.morantest(e.lm, nb2listw(eire.nb))
#' lm.morantest.sad(e.lm, nb2listw(eire.nb))
#' lm.LMtests(e.lm, nb2listw(eire.nb), test="LMerr")
#' print(localmoran.sad(e.lm, eire.nb, select=1:length(slot(eire, "polygons"))))
#' }
NULL

#' @name getisord
#' @aliases getisord go_x go_y go_xyz
#' @title Getis-Ord remote sensing example data
#'
#' @description The \code{go_xyz} data frame has 256 rows and 3 columns. Vectors \code{go_x} and \code{go_y} are of length 16 and give the centres of the grid rows and columns, 30m apart. The data start from the bottom left, Getis and Ord start from the top left - so their 136th grid cell is our 120th.
#' 
#' @format 
#' This data frame contains the following columns:
#' \itemize{
#'         \item{x} {grid eastings}
#'         \item{y} {grid northings}
#'         \item{val} {remote sensing values}
#' }
#' 
#' @source Getis, A. and Ord, J. K. 1996 Local spatial statistics: an overview. In P. Longley and M. Batty (eds) \emph{Spatial analysis: modelling in a GIS environment} (Cambridge: Geoinformation International), 266.
#' @docType data
#' @keywords datasets misc
#' 
#' @examples 
#' data(getisord)
#' image(go_x, go_y, t(matrix(go_xyz$val, nrow = 16, ncol=16, byrow = TRUE)), asp = 1)
#' text(go_xyz$x, go_xyz$y, go_xyz$val, cex = 0.7)
#' polygon(c(195, 225, 225, 195), c(195, 195, 225, 225), lwd = 2)
#' title(main = "Getis-Ord 1996 remote sensing data")
#'
NULL

#' @name house
#' @aliases house LO_nb trMat
#' @title Lucas county OH housing
#'
#' @description Data on 25,357 single family homes sold in Lucas County, Ohio, 1993-1998 from the county auditor, together with an \code{nb} neighbour object constructed as a sphere of influence graph from projected coordinates.
#' 
#' @format Formal class 'SpatialPointsDataFrame' [package "sp"] with 5 slots. The data slot is a data frame with 25357 observations on the following 24 variables.
#' \itemize{
#'         \item{price} {a numeric vector}
#'         \item{yrbuilt} {a numeric vector}
#'         \item{stories} {a factor with levels \code{one} \code{bilevel} \code{multilvl} \code{one+half} \code{two}     \code{two+half} \code{three}}
#'         \item{TLA} {a numeric vector}
#'         \item{wall} {a factor with levels \code{stucdrvt} \code{ccbtile} \code{metlvnyl} \code{brick} \code{stone} \code{wood} \code{partbrk}}
#'         \item{beds} {a numeric vector}
#'         \item{baths} {a numeric vector}
#'         \item{halfbaths} {a numeric vector}
#'         \item{frontage} {a numeric vector}
#'         \item{depth} {a numeric vector}
#'         \item{garage} {a factor with levels \code{no garage} \code{basement} \code{attached} \code{detached} \code{carport}}
#'         \item{garagesqft} {a numeric vector}
#'         \item{rooms} {a numeric vector}
#'         \item{lotsize} {a numeric vector}
#'         \item{sdate} {a numeric vector}
#'         \item{avalue} {a numeric vector}
#'         \item{s1993} {a numeric vector}
#'         \item{s1994} {a numeric vector}
#'         \item{s1995} {a numeric vector}
#'         \item{s1996} {a numeric vector}
#'         \item{s1997} {a numeric vector}
#'         \item{s1998} {a numeric vector}
#'         \item{syear} {a factor with levels \code{1993} \code{1994} \code{1995} \code{1996} \code{1997} \code{1998}}
#'         \item{age} {a numeric vector}
#' }
#' Its projection is \code{CRS(+init=epsg:2834)}, the Ohio North State Plane.
#' 
#' @source Dataset included in the Spatial Econometrics toolbox for Matlab, \url{http://www.spatial-econometrics.com/html/jplv7.zip}.
#' @docType data
#' @keywords datasets sp
#' @importClassesFrom sp SpatialPointsDataFrame
#' 
#' @examples 
#' if (requireNamespace("sp", quietly = TRUE)) {
#'   library(sp)
#'   data(house)
#'   str(house)
#'   plot(house)
#' }
"house"

#' @name lnd
#' @aliases lnd
#' @title The boroughs of London
#'
#' @description Polygons representing large administrative zones in London
#' 
#' @format 
#' \itemize{
#'     \item{NAME} {Borough name}
#'     \item{GSS_CODE} {Official code}
#'     \item{HECTARES} {How many hectares}
#'     \item{NONLD_AREA} {Area outside London}
#'     \item{ONS_INNER} {Office for national statistics code}
#'     \item{SUB_2009} {Empty column}
#'     \item{SUB_2006} {Empty column}
#'     \item{geometry} {sfc_MULTIPOLYGON}
#' }
#' 
#' @source \url{https://github.com/Robinlovelace/Creating-maps-in-R}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(lnd)
#'   summary(lnd)
#'   plot(st_geometry(lnd))
#' }
"lnd"

#' @name afcon
#' @aliases afcon africa.rook.nb afxy paper.nb
#' @title Spatial patterns of conflict in Africa 1966-78
#'
#' @description The \code{afcon} data frame has 42 rows and 5 columns, for 42 African countries, exclusing then South West Africa and Spanish Equatorial Africa and Spanish Sahara. The dataset is used in Anselin (1995), and downloaded from  before adaptation. The neighbour list object \code{africa.rook.nb} is the SpaceStat \file{rook.GAL}, but is not the list used in Anselin (1995) - \code{paper.nb} reconstructs the list used in the paper, with inserted links between Mauritania and Morocco, South Africa and Angola and Zambia, Tanzania and Zaire, and Botswana and Zambia. \code{afxy} is the coordinate matrix for the centroids of the countries.
#' 
#' @format This data frame contains the following columns:
#' \itemize{
#'         \item{x} {an easting in decimal degrees (taken as centroid of shapefile polygon)}
#'         \item{y} {an northing in decimal degrees (taken as centroid of shapefile polygon)}
#'         \item{totcon} {index of total conflict 1966-78}
#'         \item{name} {country name}
#'         \item{id} {country id number as in paper}
#' }
#' 
#' @source 
#' Anselin, L. and John O'Loughlin. 1992. Geography of international conflict and cooperation: spatial dependence and regional context in Africa.  In The New Geopolitics, ed. M. Ward, pp. 39-75.  Philadelphia, PA: Gordon and Breach. 
#' also: 
#' Anselin, L. 1995. Local indicators of spatial association, Geographical Analysis, 27, Table 1, p. 103.
#' @note All source data files prepared by Luc Anselin, Spatial Analysis Laboratory, Department of Agricultural and Consumer Economics, University of Illinois, Urbana-Champaign.
#' @docType data
#' @keywords datasets spdep
#' 
#' @examples 
#' data(afcon)
#' if (requireNamespace("spdep", quietly = TRUE)) {
#'   library(spdep)
#'   plot(africa.rook.nb, afxy)
#'   plot(diffnb(paper.nb, africa.rook.nb), afxy, col="red", add=TRUE)
#'   text(afxy, labels=attr(africa.rook.nb, "region.id"), pos=4, offset=0.4)
#'   moran.test(afcon$totcon, nb2listw(africa.rook.nb))
#'   moran.test(afcon$totcon, nb2listw(paper.nb))
#'   geary.test(afcon$totcon, nb2listw(paper.nb))
#' }
"afcon"

#' @name properties
#' @aliases properties
#' @title Dataset of properties in the municipality of Athens (sf) 
#'
#' @description A dataset of apartments in the municipality of Athens for 2017. Point location of the properties is given together with their main characteristics and the distance to the closest metro/train station.
#' 
#' @format An sf object of 1000 points with the following 6 variables.
#' \itemize{
#'   \item{id}{An unique identifier for each property.}
#'   \item{size }{The size of the property (unit: square meters)}
#'   \item{price }{The asking price (unit: euros) }
#'   \item{prpsqm }{The asking price per squre meter (unit: euroes/square meter).}
#'   \item{age }{Age of property in 2017 (unit: years).}
#'   \item{dist_metro}{The distance to closest train/metro station (unit: meters).}
#' }
#' 
#' @docType data
#' @keywords datasets sf hierarchical spatial data
#' @seealso depmunic
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   if (requireNamespace("spdep", quietly = TRUE)) {
#'     library(sf)
#'     library(spdep)
#'     
#'     data(properties)
#'     
#'     summary(properties$prpsqm)
#'     
#'     pr.nb.800 <- dnearneigh(properties, 0, 800)
#'     pr.listw <- nb2listw(pr.nb.800)
#'     
#'     moran.test(properties$prpsqm, pr.listw)
#'     moran.plot(properties$prpsqm, pr.listw, xlab = "Price/m^2", ylab = "Lagged")
#'   }
#' }
"properties"

#' @name worldbank_df
#' @aliases worldbank_df
#' @title World Bank data
#'
#' @description The object loaded is a \code{data.frame} object containing data from World Bank
#' 
#' @format Formal class 'data.frame'; the data contains a data.frame with 177 obs. of 7 variables:
#' \itemize{
#'     \item{name} {character vector of country names}
#'     \item{iso_a2} {character vector of ISO 2 character country codes}
#'     \item{HDI} {human development index (HDI)}
#'     \item{urban_pop} {urban population}
#'     \item{unemployment} {unemployment, total (\% of total labor force)}
#'     \item{pop_growth} {population growth (annual \%)}
#'     \item{literacy} {adult literacy rate, population 15+ years, both sexes (\%)}
#' }
#' 
#' @seealso 
#' See the wbstats package: https://cran.r-project.org/web/packages/wbstats
#' 
#' @source \url{http://data.worldbank.org/}
#' @docType data
#' @keywords datasets
#' @examples 
#' data(worldbank_df)
#' # or
#' worldbank_df <- read.csv(system.file("misc/worldbank_df.csv", package="spData"))
#' 
#' summary(worldbank_df)
#' 
"worldbank_df"

#' @name nz_height
#' @title High points in New Zealand
#'
#' @description 
#' 
#' Top 101 heighest points in New Zealand (2017).
#' See \url{https://data.linz.govt.nz/layer/50284-nz-height-points-topo-150k/} for details.
#' 
#' @format FORMAT:
#' \itemize{
#'     \item{t50_fid} {ID}
#'     \item{elevation} {Height above sea level in m}
#'     \item{geometry} {sfc_POINT}
#' }
#' 
#' @source \url{https://data.linz.govt.nz}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   summary(nz_height)
#'   plot(nz$geom)
#'   plot(nz_height$geom, add = TRUE)
#' }
#' \dontrun{
#' library(dplyr)
#' # After downloading data
#' unzip("lds-nz-height-points-topo-150k-SHP.zip")
#' nz_height = st_read("nz-height-points-topo-150k.shp") %>% 
#'   top_n(n = 100, wt = elevation)
#' library(tmap)
#' tmap_mode("view")
#' qtm(nz) +
#'   qtm(nz_height)
#' f = list.files(pattern = "*nz-height*")
#' file.remove(f)
#' }
"nz_height"

#' @name hawaii
#' @title Hawaii multipolygon
#'
#' @description The object loaded is a \code{sf} object containing the state of 
#' Hawaii from the US Census Bureau
#' with a few variables from American Community Survey (ACS)
#' 
#' @format Formal class 'sf' [package "sf"]; the data contains a data.frame with 1 obs. of 7 variables:
#' \itemize{
#'     \item{GEOID} {character vector of geographic identifiers}
#'     \item{NAME} {character vector of state names}
#'     \item{REGION} {character vector of region names}
#'     \item{AREA} {area in square kilometers of units class}
#'     \item{total_pop_10} {numerical vector of total population in 2010}
#'     \item{total_pop_15} {numerical vector of total population in 2015}
#'     \item{geometry} {sfc_MULTIPOLYGON}
#' }
#' The object is in projected coordinates using Hawaii Albers Equal Area Conic (ESRI:102007).
#' 
#' @seealso 
#' See the tigris package: https://cran.r-project.org/package=tigris
#' 
#' @source \url{https://www.census.gov/geo/maps-data/data/tiger-line.html}
#' @docType data
#' @keywords datasets sf
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(hawaii)
#' 
#'   plot(hawaii["total_pop_15"])
#' }
"hawaii"

#' @name us_states
#' @title US states polygons
#'
#' @description The object loaded is a \code{sf} object containing the contiguous United States data from the US Census Bureau
#' with a few variables from American Community Survey (ACS)
#' 
#' @format Formal class 'sf' [package "sf"]; the data contains a data.frame with 49 obs. of 7 variables:
#' \itemize{
#'     \item{GEOID} {character vector of geographic identifiers}
#'     \item{NAME} {character vector of state names}
#'     \item{REGION} {character vector of region names}
#'     \item{AREA} {area in square kilometers of units class}
#'     \item{total_pop_10} {numerical vector of total population in 2010}
#'     \item{total_pop_15} {numerical vector of total population in 2015}
#'     \item{geometry} {sfc_MULTIPOLYGON}
#' }
#' The object is in geographical coordinates using the NAD83 datum.
#' 
#' @seealso 
#' See the tigris package: https://cran.r-project.org/package=tigris
#' 
#' @source \url{https://www.census.gov/geo/maps-data/data/tiger-line.html}
#' @docType data
#' @keywords datasets sf
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(us_states)
#' 
#'   plot(us_states["REGION"])
#' }
"us_states"

#' @name seine
#' @aliases rivers
#' @title Small river network in France
#'
#' @description 
#' 
#' Lines representing the Seine, Marne and Yonne rivers.
#' 
#' @format FORMAT:
#' \itemize{
#'     \item{name} {name}
#'     \item{geometry} {sfc_MULTILINESTRING}
#' }
#' The object is in the RGF93 / Lambert-93 CRS.
#' 
#' @seealso 
#' See the rnaturalearth package: https://cran.r-project.org/package=rnaturalearth
#' 
#' @source \url{http://www.naturalearthdata.com/}
#' 
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   seine
#'   plot(seine)
#' }
#' \dontrun{
#' library(sf)
#' library(rnaturalearth)
#' library(tidyverse)
#' 
#' seine = ne_download(scale = 10, type = "rivers_lake_centerlines", 
#'                     category = "physical", returnclass = "sf") %>% 
#'         filter(name %in% c("Yonne", "Seine", "Marne")) %>% 
#'         select(name = name_en) %>% 
#'         st_transform(2154)
#' }
"seine"

#' @name cycle_hire
#' @aliases cycle_hire
#' @title Cycle hire points in London
#'
#' @description 
#' 
#' Points
#' representing cycle hire points accross London. 
#' 
#' @format FORMAT:
#' \itemize{
#'     \item{id} {Id of the hire point}
#'     \item{name} {Name of the point}
#'     \item{area} {Area they are in}
#'     \item{nbikes} {The number of bikes currently parked there}
#'     \item{nempty} {The number of empty places}
#'     \item{geometry} {sfc_POINT}
#' }
#' 
#' @source \url{https://cyclehireapp.com/cyclehirelive/cyclehire.csv}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(cycle_hire)
#'   # or
#'   cycle_hire <- st_read(system.file("shapes/cycle_hire.geojson", package="spData"))
#'   
#'   plot(cycle_hire)
#' }
#' 
#' \dontrun{
#' # Download the data
#' cycle_hire = readr::read_csv("http://cyclehireapp.com/cyclehirelive/cyclehire.csv", 
#'   col_names = FALSE, skip = TRUE)
#' cycle_hire = cycle_hire[c_names]
#' c_names = c("id", "name", "area", "lat", "lon", "nbikes", "nempty")
#' cycle_hire = st_sf(cycle_hire, st_multipoint(c_names[c("lon", "lat")]))
#' }
"cycle_hire"

#' @name wheat
#' @aliases wheat
#' @title Mercer and Hall wheat yield data
#'
#' @description Mercer and Hall wheat yield data, based on version in Cressie (1993), p. 455.
#' 
#' @format The format of the object generated by running \code{data(wheat)} is a three column data frame made available by Hongfei Li. The example section shows how to convert this to the object used in demonstrating the \code{aple} function, and is a formal class 'SpatialPolygonsDataFrame' [package "sp"] with 5 slots; the data slot is a data frame with 500 observations on the following 6 variables.
#' \itemize{
#'         \item{lat} {local coordinates northings ordered north to south}
#'         \item{yield} {Mercer and Hall wheat yield data}
#'         \item{r} {rows south to north; levels in distance units of plot centres}
#'         \item{c} {columns west to east; levels in distance units of plot centres}
#'         \item{lon} {local coordinates eastings}
#'         \item{lat1} {local coordinates northings ordered south to north}
#' }
#' @note The value of 4.03 was changed to 4.33 (wheat[71,]) 13 January 2014; thanks to Sandy Burden; cross-checked with http://www.itc.nl/personal/rossiter/teach/R/mhw.csv, which agrees.
#' 
#' @source Cressie, N. A. C. (1993) Statistics for Spatial Data. Wiley, New York, p. 455.
#' @references Mercer, W. B. and Hall, A. D. (1911) The experimental error of field trials. Journal of Agricultural Science 4, 107-132.
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' \dontrun{
#' data(wheat)
#' wheat$lat1 <- 69 - wheat$lat
#' wheat$r <- factor(wheat$lat1)
#' wheat$c <- factor(wheat$lon)
#' wheat_sp <- wheat
#' coordinates(wheat_sp) <- c("lon", "lat1")
#' wheat_spg <- wheat_sp
#' 
#' gridded(wheat_spg) <- TRUE
#' wheat_spl <- as(wheat_spg, "SpatialPolygons")
#' df <- as(wheat_spg, "data.frame")
#' row.names(df) <- sapply(slot(wheat_spl, "polygons"),
#'                         function(x) slot(x, "ID"))
#' wheat <- SpatialPolygonsDataFrame(wheat_spl, data=df)
#' }
#' 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   wheat <- st_read(system.file("shapes/wheat.shp", package="spData"))
#'   plot(wheat)
#' }
"wheat"

#' @name grain.tif
#' @title Artificial raster dataset representing grain sizes
#' @description The ratified raster dataset represents grain sizes with the
#'   three classes clay, silt and sand, and WGS84 as a coordinate reference
#'   system.
#' @docType data
#' @keywords datasets raster
#' 
#' @examples 
#' system.file("raster/grain.tif", package = "spData")
NULL

#' @name depmunic
#' @aliases depmunic
#' @title Municipality departments of Athens (Sf)
#'
#' @description  The geographic boundaries of departments (sf) of the municipality of Athens. This is accompanied by various characteristics in these areas.
#' 
#' @format An sf object of 7 polygons with the following 7 variables.
#' \itemize{
#'   \item{num_dep}{An unique identifier for each municipality department.}
#'   \item{airbnb }{The number of airbnb properties in 2017}
#'   \item{museums }{The number of museums}
#'   \item{population }{The population recorded in census at 2011.}
#'   \item{pop_rest }{The number of citizens that the origin is a non european country.}
#'   \item{greensp}{The area of green spaces (unit: square meters).}
#'   \item{area}{The area of the polygon (unit: square kilometers). }
#' }
#' 
#' @docType data
#' @keywords datasets sf
#' @seealso properties
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(depmunic)
#'   
#'   depmunic$foreigners <- 100*depmunic$pop_rest/depmunic$population
#'   plot(depmunic["foreigners"], key.pos=1)
#' }
"depmunic"

#' @name state.vbm
#' @aliases state.vbm
#' @title US State Visibility Based Map
#'
#' @description A SpatialPolygonsDataFrame object (for use with the maptools package) to plot a Visibility Based Map.
#' 
#' @details A SpatialPolygonsDataFrame object (for use with the maptools package) to plot a map of the US states where the sizes of the states have been adjusted to be more equal. 
#' This map can be useful for plotting state data using colors patterns without the larger states dominating and the smallest states being lost.
#' The original map is copyrighted by Mark Monmonier.  Official publications based on this map should acknowledge him. Comercial publications of maps based on this probably need permission from him to use. 
#' 
#' @source The data was converted from the maps library for S-PLUS.  S-PLUS uses the map with permission from the author. This version of the data has not received permission from the author (no attempt made, not that it was refused), most of my uses I feel fall under fair use and do not violate copyright, but you will need to decide for yourself and your applications.
#' 
#' @author Greg Snow \email{greg.snow@imail.org} (of this compilation)
#' 
#' @references   
#' \url{http://www.markmonmonier.com/index.htm},
#' \url{http://www.math.yorku.ca/SCS/Gallery/bright-ideas.html}
#' 
#' @docType data
#' @keywords datasets sp
#' @importClassesFrom sp SpatialPolygonsDataFrame
#' 
#' @examples 
#' if (requireNamespace("sp", quietly = TRUE)) {
#'   library(sp)
#'   data(state.vbm)
#'   plot(state.vbm)
#' 
#'   tmp <- state.x77[, 'HS Grad']
#'   tmp2 <- cut(tmp, seq(min(tmp), max(tmp), length.out=11),
#'             include.lowest=TRUE)
#'   plot(state.vbm, col=cm.colors(10)[tmp2])
#' }
"state.vbm"

#' @name nz
#' @aliases new_zealand
#' @title Regions in New Zealand
#'
#' @description 
#' 
#' Polygons representing the 16 regions of New Zealand (2018).
#' See \url{https://en.wikipedia.org/wiki/Regions_of_New_Zealand} for a description of these regions
#' and \url{https://www.stats.govt.nz} for information on the data source
#' 
#' @format FORMAT:
#' \itemize{
#'     \item{Name} {Name}
#'     \item{Island} {Island}
#'     \item{Land_area} {Land area}
#'     \item{Population} {Population}
#'     \item{Median_income} {Median income (NZD)}
#'     \item{Sex_ratio} {Sex ratio (male/female)}
#'     \item{geom} {sfc_MULTIPOLYGON}
#' }
#' 
#' @seealso 
#' See the nzcensus package: https://github.com/ellisp/nzelect
#' 
#' @source \url{https://www.stats.govt.nz}
#' @source \url{https://en.wikipedia.org/wiki/Regions_of_New_Zealand}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   summary(nz)
#'   plot(nz)
#' }
#' \dontrun{
#' # Find "Regional Council 2018 Clipped (generalised)"
#' # select the GeoPackage option in the "Vectors/tables" dropdown
#' # at https://datafinder.stats.govt.nz/data/ (requires registration)
#' # Save the result as:
#' unzip("statsnzregional-council-2018-clipped-generalised-GPKG.zip")
#' library(sf)
#' library(tidyverse)
#' nz_full = st_read("regional-council-2018-clipped-generalised.gpkg")
#' print(object.size(nz_full), units = "Kb") # 14407.2 Kb
#' nz = rmapshaper::ms_simplify(nz_full, keep = 0.001, sys = TRUE)
#' print(object.size(nz), units = "Kb") # 39.9 Kb
#' names(nz)
#' nz$REGC2018_V1_00_NAME
#' nz = filter(nz, REGC2018_V1_00_NAME != "Area Outside Region") %>%
#'         select(Name = REGC2018_V1_00_NAME, `Land_area` = LAND_AREA_SQ_KM)
#' # regions basic info
#' # devtools::install_github("hadley/rvest")
#' library(rvest)
#' doc = read_html("https://en.wikipedia.org/wiki/Regions_of_New_Zealand") %>%
#'         html_nodes("div table")
#' tab = doc[[3]] %>% html_table()
#' tab = tab %>% select(Name = Region, Population = `Population[20]`, Island)
#' tab = tab %>% mutate(Population = str_replace_all(Population, ",", "")) %>%
#'         mutate(Population = as.numeric(Population)) %>%
#'         mutate(Name = str_remove_all(Name, " \\([1-9]\\)?.+"))
#' nz$Name = as.character(nz$Name)
#' nz$Name = str_remove(nz$Name, " Region")
#' nz$Name %in% tab$Name
#' # regions additional info
#' library(nzcensus)
#' nz_add_data = REGC2013 %>% 
#'         select(Name = REGC2013_N, Median_income = MedianIncome2013, 
#'                PropFemale2013, PropMale2013) %>% 
#'         mutate(Sex_ratio = PropMale2013 / PropFemale2013) %>% 
#'         mutate(Name = gsub(" Region", "", Name)) %>% 
#'         select(Name, Median_income, Sex_ratio)
#' # data join
#' nz = left_join(nz, tab, by = "Name") %>% 
#'         left_join(nz_add_data, by = "Name") %>% 
#'         select(Name, Island, Land_area, Population, Median_income, Sex_ratio)
#' }
"nz"

#' @name auckland
#' @aliases auckland auckland.nb auckpolys
#' @title Marshall's infant mortality in Auckland dataset
#'
#' @description (Use \code{example(auckland)} to load the data from shapefile and generate neighbour list on the fly).  The \code{auckland} data frame has 167 rows (census area units --- CAU) and 4 columns. The dataset also includes the "nb" object \code{auckland.nb} of neighbour relations based on contiguity, and the "polylist" object \code{auckpolys} of polygon boundaries for the CAU. The \code{auckland} data frame includes the following columns:
#' 
#' @format This data frame contains the following columns:
#' \itemize{
#'         \item{Easting} {a numeric vector of x coordinates in an unknown spatial reference system}
#'         \item{Northing} {a numeric vector of y coordinates in an unknown spatial reference system}
#'         \item{M77_85} {a numeric vector of counts of infant (under 5 years of age) deaths in Auckland, 1977-1985}
#'         \item{Und5_81} {a numeric vector of population under 5 years of age at the 1981 Census}
#' }
#' 
#' @details The contiguous neighbours object does not completely replicate results in the sources, and was reconstructed from \code{auckpolys}; examination of figures in the sources suggests that there are differences in detail, although probably not in substance.
#' @source Marshall R M (1991) Mapping disease and mortality rates using Empirical Bayes Estimators, Applied Statistics, 40, 283--294; Bailey T, Gatrell A (1995) Interactive Spatial Data Analysis, Harlow: Longman --- INFOMAP data set used with permission.
#' @docType data
#' @keywords datasets sp
#' 
#' @examples 
#' if (requireNamespace("rgdal", quietly = TRUE)) {
#'   library(rgdal)
#'   auckland <- readOGR(system.file("shapes/auckland.shp", package="spData")[1])
#'   plot(auckland)
#'   if (requireNamespace("spdep", quietly = TRUE)) {
#'     library(spdep)
#'     auckland.nb <- poly2nb(auckland)
#'   }
#' }
#' 

"auckland"

#' @name columbus
#' @aliases columbus col.gal.nb coords polys bbs
#' @title Columbus OH spatial analysis data set
#'
#' @description The \code{columbus} data frame has 49 rows and 22 columns. Unit of analysis: 49 neighbourhoods in Columbus, OH, 1980 data. In addition the data set includes a \code{polylist} object \code{polys} with the boundaries of the neighbourhoods, a matrix of polygon centroids \code{coords}, and \code{col.gal.nb}, the neighbours list from an original GAL-format file. The matrix \code{bbs} is DEPRECATED, but retained for other packages using this data set.
#' 
#' @format This data frame contains the following columns:
#'        \itemize{
#'                \item{AREA} {computed by ArcView}
#'                \item{PERIMETER} {computed by ArcView}
#'                \item{COLUMBUS_} {internal polygon ID (ignore)}
#'                \item{COLUMBUS_I} {another internal polygon ID (ignore)}
#'                \item{POLYID} {yet another polygon ID}
#'                \item{NEIG} {neighborhood id value (1-49);
#'                        conforms to id value used in Spatial Econometrics book.}
#'                \item{HOVAL} {housing value (in \$1,000)}
#'                \item{INC} {household income (in \$1,000)}
#'                \item{CRIME} {residential burglaries and vehicle thefts per thousand
#'                        households in the neighborhood}
#'                \item{OPEN} {open space in neighborhood}
#'                \item{PLUMB} {percentage housing units without plumbing}
#'                \item{DISCBD} {distance to CBD}
#'                \item{X} {x coordinate (in arbitrary digitizing units, not polygon coordinates)}
#'                \item{Y} {y coordinate (in arbitrary digitizing units, not polygon coordinates)}
#'                \item{NSA} {north-south dummy (North=1)}
#'                \item{NSB} {north-south dummy (North=1)}
#'                \item{EW} {east-west dummy (East=1)}
#'                \item{CP} {core-periphery dummy (Core=1)}
#'                \item{THOUS} {constant=1,000}
#'                \item{NEIGNO} {NEIG+1,000, alternative neighborhood id value}
#'        }
#' @details The row names of \code{columbus} and the \code{region.id} attribute of \code{polys} are set to \code{columbus$NEIGNO}.
#' @source Anselin, Luc.  1988.  Spatial econometrics: methods and models.  Dordrecht: Kluwer Academic, Table 12.1 p. 189.
#' @note All source data files prepared by Luc Anselin, Spatial Analysis Laboratory, Department of Agricultural and Consumer Economics, University of Illinois, Urbana-Champaign, http://sal.agecon.uiuc.edu/datasets/columbus.zip.
#' @docType data
#' @keywords datasets sp spdep
#' 
#' @examples 
#' if (requireNamespace("rgdal", quietly = TRUE)) {
#'   library(rgdal)
#'   columbus <- readOGR(system.file("shapes/columbus.shp", package="spData")[1])
#'   plot(columbus)
#' }
#' 
#' if (requireNamespace("spdep", quietly = TRUE)) {
#'   library(spdep)
#'   col.gal.nb <- read.gal(system.file("weights/columbus.gal", package="spData")[1])
#' }
"columbus"

#' @name congruent
#' @aliases incongruent aggregating_zones
#' @title Datasets to illustrate the concept of spatial congruence
#'
#' @description Sample of old (incongruent) and new (congruent) administrative zones
#' from UK statistical agencies
#' 
#' @format 
#' Simple feature geographic data in a projected CRS (OSGB) with random values assigned
#' for teaching purposes.
#' 
#' @source \url{https://en.wikipedia.org/wiki/ONS_coding_system}
#' @docType data
#' @keywords datasets sf
#' 
#' @examples 
#' if(requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   plot(aggregating_zones$geometry, lwd = 5)
#'   plot(congruent$geometry, add = TRUE, border = "green", lwd = 2)
#'   plot(incongruent$geometry, add = TRUE, border = "blue", col = NA)
#'   rbind(congruent, incongruent)
#' }
#' # Code used to download the data:
#' \dontrun{
#' devtools::install_github("robinlovelace/ukboundaries")
#' library(sf)
#' library(tmap)
#' library(dplyr)
#' library(ukboundaries)
#' sel = grepl("003|004", msoa2011_lds$geo_label)
#' aggregating_zones = st_transform(msoa2011_lds[sel, ], 27700)
#' # find lsoas in the aggregating_zones
#' lsoa_touching = st_transform(lsoa2011_lds, 27700)[aggregating_zones, ]
#' lsoa_cents = st_centroid(lsoa_touching)
#' lsoa_cents = lsoa_cents[aggregating_zones, ]
#' sel = lsoa_touching$geo_code %in% lsoa_cents$geo_code
#' # same for ed zones
#' ed_touching = st_transform(ed1981, 27700)[aggregating_zones, ]
#' ed_cents = st_centroid(ed_touching)
#' ed_cents = ed_cents[aggregating_zones, ]
#' incongruent_agg_ed = ed_touching[ed_cents, ]
#' set.seed(2017)
#' incongruent_agg_ed$value = rnorm(nrow(incongruent_agg_ed), mean = 5)
#' congruent = aggregate(incongruent_agg_ed["value"], lsoa_touching[sel, ], mean)
#' congruent$level = "Congruent"
#' congruent = congruent[c("level", "value")]
#' incongruent_cents = st_centroid(incongruent_agg_ed)
#' aggregating_value = st_join(incongruent_cents, congruent)$value.y
#' incongruent_agg = aggregate(incongruent_agg_ed["value"], list(aggregating_value), FUN = mean)
#' incongruent_agg$level = "Incongruent"
#' incongruent = incongruent_agg[c("level", "value")]
#' summary(st_geometry_type(congruent))
#' summary(st_geometry_type(incongruent))
#' incongruent = st_cast(incongruent, "MULTIPOLYGON")
#' summary(st_geometry_type(incongruent))
#' summary(st_geometry_type(aggregating_zones))
#' devtools::use_data(congruent, overwrite = TRUE)
#' devtools::use_data(incongruent, overwrite = TRUE)
#' devtools::use_data(aggregating_zones, overwrite = TRUE)
#' }
"congruent"

#' @name hopkins
#' @aliases hopkins
#' @title Hopkins burnt savanna herb remains
#'
#' @description A 20m square is divided into 40 by 40 0.5m quadrats. Observations are in tens of grams of herb remains, 0 being from 0g to less than 10g, and so on. Analysis was mostly conducted using the interior 32 by 32 grid.
#' 
#' @format num [1:40, 1:40] 0 0 0 0 0 0 0 0 0 1 ...
#' 
#' @source Upton, G., Fingleton, B. 1985 Spatial data analysis by example: point pattern and quatitative data, Wiley, pp. 38--39.
#' @references Hopkins, B., 1965 Observations on savanna burning in the Olokemeji Forest Reserve, Nigeria. Journal of Applied Ecology, 2, 367--381.
#' @docType data
#' @keywords datasets misc
#' 
#' @examples 
#' data(hopkins)
#' image(1:32, 1:32, hopkins[5:36,36:5], breaks=c(-0.5, 3.5, 20),
#'       col=c("white", "black"))
"hopkins"

#' @name elect80
#' @aliases elect80 elect80_lw k4 dll e80_queen
#' @title 1980 Presidential election results
#'
#' @description A data set for 1980 Presidential election results covering 3,107 US counties using geographical coordinates. In addition, three spatial neighbour objects, \code{k4} not using Great Circle distances, \code{dll} using Great Circle distances, and \code{e80_queen} of Queen contiguities for equivalent County polygons taken from file \code{co1980p020.tar.gz} on the USGS National Atlas site, and a spatial weights object imported from \code{elect.ford} - a 4-nearest neighbour non-GC row-standardised object, but with coercion to symmetry.
#' 
#' @format 
#' A SpatialPointsDataFrame with 3107 observations on the following 7 variables.
#' \itemize{
#'         \item{FIPS} {a factor of county FIPS codes}
#'         \item{long} {a numeric vector of longitude values}
#'         \item{lat} {a numeric vector of latitude values}
#'         \item{pc_turnout} {Votes cast as proportion of population over age 19 eligible to vote}
#'         \item{pc_college} {Population with college degrees as proportion of population over age 19 eligible to vote}
#'         \item{pc_homeownership} {Homeownership as proportion of population over age 19 eligible to vote}
#'         \item{pc_income} {Income per capita of population over age 19 eligible to vote}
#' }
#' 
#' @source Pace, R. Kelley and Ronald Barry. 1997. "Quick Computation of Spatial Autoregressive Estimators", in Geographical Analysis; sourced from the data folder in the Spatial Econometrics Toolbox for Matlab, \url{http://www.spatial-econometrics.com/html/jplv7.zip}, files \code{elect.dat} and \code{elect.ford} (with the final line dropped).
#' @docType data
#' @keywords datasets sp
#' @importClassesFrom sp SpatialPointsDataFrame
#' 
#' @examples 
#' if (requireNamespace("sp", quietly = TRUE)) {
#'   library(sp)
#'   data(elect80)
#'   summary(elect80)
#'   plot(elect80)
#' }
"elect80"

#' @name alaska
#' @title Alaska multipolygon
#'
#' @description The object loaded is a \code{sf} object containing the state of 
#' Alaska from the US Census Bureau
#' with a few variables from American Community Survey (ACS)
#' 
#' @format Formal class 'sf' [package "sf"]; the data contains a data.frame with 1 obs. of 7 variables:
#' \itemize{
#'     \item{GEOID: character vector of geographic identifiers}
#'     \item{NAME: character vector of state names}
#'     \item{REGION: character vector of region names}
#'     \item{AREA: area in square kilometers of units class}
#'     \item{total_pop_10: numerical vector of total population in 2010}
#'     \item{total_pop_15: numerical vector of total population in 2015}
#'     \item{geometry: sfc_MULTIPOLYGON}
#' }
#' The object is in projected coordinates using Alaska Albers (EPSG:3467).
#' 
#' @seealso 
#' See the tigris package: https://cran.r-project.org/package=tigris
#' 
#' @source \url{https://www.census.gov/geographies/mapping-files/time-series/geo/tiger-line-file.html}
#' @docType data
#' @keywords datasets sf
#' @examples 
#' if (requireNamespace("sf", quietly = TRUE)) {
#'   library(sf)
#'   data(alaska)
#' 
#'   plot(alaska["total_pop_15"])
#' }
"alaska"

#' @name elev.tif
#' @title Artificial elevation raster data set
#'
#' @description The raster data represents elevation in meters and uses WGS84 as
#'   a coordinate reference system.
#' @docType data
#' @keywords datasets raster
#' 
#' @examples 
#' system.file("raster/elev.tif", package = "spData")
NULL

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seine.R
\docType{data}
\name{seine}
\alias{seine}
\alias{rivers}
\title{Small river network in France}
\format{FORMAT:
\itemize{
    \item{name} {name}
    \item{geometry} {sfc_MULTILINESTRING}
}
The object is in the RGF93 / Lambert-93 CRS.}
\source{
\url{http://www.naturalearthdata.com/}
}
\usage{
seine
}
\description{
Lines representing the Seine, Marne and Yonne rivers.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  seine
  plot(seine)
}
\dontrun{
library(sf)
library(rnaturalearth)
library(tidyverse)

seine = ne_download(scale = 10, type = "rivers_lake_centerlines", 
                    category = "physical", returnclass = "sf") \%>\% 
        filter(name \%in\% c("Yonne", "Seine", "Marne")) \%>\% 
        select(name = name_en) \%>\% 
        st_transform(2154)
}
}
\seealso{
See the rnaturalearth package: https://cran.r-project.org/package=rnaturalearth
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nz_height.R
\docType{data}
\name{nz_height}
\alias{nz_height}
\title{High points in New Zealand}
\format{FORMAT:
\itemize{
    \item{t50_fid} {ID}
    \item{elevation} {Height above sea level in m}
    \item{geometry} {sfc_POINT}
}}
\source{
\url{https://data.linz.govt.nz}
}
\usage{
nz_height
}
\description{
Top 101 heighest points in New Zealand (2017).
See \url{https://data.linz.govt.nz/layer/50284-nz-height-points-topo-150k/} for details.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  summary(nz_height)
  plot(nz$geom)
  plot(nz_height$geom, add = TRUE)
}
\dontrun{
library(dplyr)
# After downloading data
unzip("lds-nz-height-points-topo-150k-SHP.zip")
nz_height = st_read("nz-height-points-topo-150k.shp") \%>\% 
  top_n(n = 100, wt = elevation)
library(tmap)
tmap_mode("view")
qtm(nz) +
  qtm(nz_height)
f = list.files(pattern = "*nz-height*")
file.remove(f)
}
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cycle_hire.R
\docType{data}
\name{cycle_hire}
\alias{cycle_hire}
\title{Cycle hire points in London}
\format{FORMAT:
\itemize{
    \item{id} {Id of the hire point}
    \item{name} {Name of the point}
    \item{area} {Area they are in}
    \item{nbikes} {The number of bikes currently parked there}
    \item{nempty} {The number of empty places}
    \item{geometry} {sfc_POINT}
}}
\source{
\url{https://cyclehireapp.com/cyclehirelive/cyclehire.csv}
}
\usage{
cycle_hire
}
\description{
Points
representing cycle hire points accross London.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(cycle_hire)
  # or
  cycle_hire <- st_read(system.file("shapes/cycle_hire.geojson", package="spData"))
  
  plot(cycle_hire)
}

\dontrun{
# Download the data
cycle_hire = readr::read_csv("http://cyclehireapp.com/cyclehirelive/cyclehire.csv", 
  col_names = FALSE, skip = TRUE)
cycle_hire = cycle_hire[c_names]
c_names = c("id", "name", "area", "lat", "lon", "nbikes", "nempty")
cycle_hire = st_sf(cycle_hire, st_multipoint(c_names[c("lon", "lat")]))
}
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/columbus.R
\docType{data}
\name{columbus}
\alias{columbus}
\alias{col.gal.nb}
\alias{coords}
\alias{polys}
\alias{bbs}
\title{Columbus OH spatial analysis data set}
\format{This data frame contains the following columns:
       \itemize{
               \item{AREA} {computed by ArcView}
               \item{PERIMETER} {computed by ArcView}
               \item{COLUMBUS_} {internal polygon ID (ignore)}
               \item{COLUMBUS_I} {another internal polygon ID (ignore)}
               \item{POLYID} {yet another polygon ID}
               \item{NEIG} {neighborhood id value (1-49);
                       conforms to id value used in Spatial Econometrics book.}
               \item{HOVAL} {housing value (in \$1,000)}
               \item{INC} {household income (in \$1,000)}
               \item{CRIME} {residential burglaries and vehicle thefts per thousand
                       households in the neighborhood}
               \item{OPEN} {open space in neighborhood}
               \item{PLUMB} {percentage housing units without plumbing}
               \item{DISCBD} {distance to CBD}
               \item{X} {x coordinate (in arbitrary digitizing units, not polygon coordinates)}
               \item{Y} {y coordinate (in arbitrary digitizing units, not polygon coordinates)}
               \item{NSA} {north-south dummy (North=1)}
               \item{NSB} {north-south dummy (North=1)}
               \item{EW} {east-west dummy (East=1)}
               \item{CP} {core-periphery dummy (Core=1)}
               \item{THOUS} {constant=1,000}
               \item{NEIGNO} {NEIG+1,000, alternative neighborhood id value}
       }}
\source{
Anselin, Luc.  1988.  Spatial econometrics: methods and models.  Dordrecht: Kluwer Academic, Table 12.1 p. 189.
}
\usage{
columbus
}
\description{
The \code{columbus} data frame has 49 rows and 22 columns. Unit of analysis: 49 neighbourhoods in Columbus, OH, 1980 data. In addition the data set includes a \code{polylist} object \code{polys} with the boundaries of the neighbourhoods, a matrix of polygon centroids \code{coords}, and \code{col.gal.nb}, the neighbours list from an original GAL-format file. The matrix \code{bbs} is DEPRECATED, but retained for other packages using this data set.
}
\details{
The row names of \code{columbus} and the \code{region.id} attribute of \code{polys} are set to \code{columbus$NEIGNO}.
}
\note{
All source data files prepared by Luc Anselin, Spatial Analysis Laboratory, Department of Agricultural and Consumer Economics, University of Illinois, Urbana-Champaign, http://sal.agecon.uiuc.edu/datasets/columbus.zip.
}
\examples{
if (requireNamespace("rgdal", quietly = TRUE)) {
  library(rgdal)
  columbus <- readOGR(system.file("shapes/columbus.shp", package="spData")[1])
  plot(columbus)
}

if (requireNamespace("spdep", quietly = TRUE)) {
  library(spdep)
  col.gal.nb <- read.gal(system.file("weights/columbus.gal", package="spData")[1])
}
}
\keyword{datasets}
\keyword{sp}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/properties.R
\docType{data}
\name{properties}
\alias{properties}
\title{Dataset of properties in the municipality of Athens (sf)}
\format{
An sf object of 1000 points with the following 6 variables.
\itemize{
  \item{id}{An unique identifier for each property.}
  \item{size }{The size of the property (unit: square meters)}
  \item{price }{The asking price (unit: euros) }
  \item{prpsqm }{The asking price per squre meter (unit: euroes/square meter).}
  \item{age }{Age of property in 2017 (unit: years).}
  \item{dist_metro}{The distance to closest train/metro station (unit: meters).}
}
}
\usage{
properties
}
\description{
A dataset of apartments in the municipality of Athens for 2017. Point location of the properties is given together with their main characteristics and the distance to the closest metro/train station.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  if (requireNamespace("spdep", quietly = TRUE)) {
    library(sf)
    library(spdep)
    
    data(properties)
    
    summary(properties$prpsqm)
    
    pr.nb.800 <- dnearneigh(properties, 0, 800)
    pr.listw <- nb2listw(pr.nb.800)
    
    moran.test(properties$prpsqm, pr.listw)
    moran.plot(properties$prpsqm, pr.listw, xlab = "Price/m^2", ylab = "Lagged")
  }
}
}
\seealso{
depmunic
}
\keyword{data}
\keyword{datasets}
\keyword{hierarchical}
\keyword{sf}
\keyword{spatial}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/afcon.R
\docType{data}
\name{afcon}
\alias{afcon}
\alias{africa.rook.nb}
\alias{afxy}
\alias{paper.nb}
\title{Spatial patterns of conflict in Africa 1966-78}
\format{This data frame contains the following columns:
\itemize{
        \item{x} {an easting in decimal degrees (taken as centroid of shapefile polygon)}
        \item{y} {an northing in decimal degrees (taken as centroid of shapefile polygon)}
        \item{totcon} {index of total conflict 1966-78}
        \item{name} {country name}
        \item{id} {country id number as in paper}
}}
\source{
Anselin, L. and John O'Loughlin. 1992. Geography of international conflict and cooperation: spatial dependence and regional context in Africa.  In The New Geopolitics, ed. M. Ward, pp. 39-75.  Philadelphia, PA: Gordon and Breach. 
also: 
Anselin, L. 1995. Local indicators of spatial association, Geographical Analysis, 27, Table 1, p. 103.
}
\usage{
afcon
}
\description{
The \code{afcon} data frame has 42 rows and 5 columns, for 42 African countries, exclusing then South West Africa and Spanish Equatorial Africa and Spanish Sahara. The dataset is used in Anselin (1995), and downloaded from  before adaptation. The neighbour list object \code{africa.rook.nb} is the SpaceStat \file{rook.GAL}, but is not the list used in Anselin (1995) - \code{paper.nb} reconstructs the list used in the paper, with inserted links between Mauritania and Morocco, South Africa and Angola and Zambia, Tanzania and Zaire, and Botswana and Zambia. \code{afxy} is the coordinate matrix for the centroids of the countries.
}
\note{
All source data files prepared by Luc Anselin, Spatial Analysis Laboratory, Department of Agricultural and Consumer Economics, University of Illinois, Urbana-Champaign.
}
\examples{
data(afcon)
if (requireNamespace("spdep", quietly = TRUE)) {
  library(spdep)
  plot(africa.rook.nb, afxy)
  plot(diffnb(paper.nb, africa.rook.nb), afxy, col="red", add=TRUE)
  text(afxy, labels=attr(africa.rook.nb, "region.id"), pos=4, offset=0.4)
  moran.test(afcon$totcon, nb2listw(africa.rook.nb))
  moran.test(afcon$totcon, nb2listw(paper.nb))
  geary.test(afcon$totcon, nb2listw(paper.nb))
}
}
\keyword{datasets}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grain.R
\docType{data}
\name{grain}
\alias{grain}
\title{Artificial raster dataset representing grain sizes}
\format{An object of class \code{RasterLayer} of dimension 6 x 6 x 1.}
\usage{
grain
}
\description{
The ratified raster dataset represents grain sizes with the
  three classes clay, silt and sand, and WGS84 as a coordinate reference
  system.
}
\examples{
if (requireNamespace("raster", quietly = TRUE)) {
  library(raster)
  data(grain)
  grain
}
}
\keyword{datasets}
\keyword{raster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/state.vbm.R
\docType{data}
\name{state.vbm}
\alias{state.vbm}
\title{US State Visibility Based Map}
\format{An object of class \code{SpatialPolygonsDataFrame} with 50 rows and 2 columns.}
\source{
The data was converted from the maps library for S-PLUS.  S-PLUS uses the map with permission from the author. This version of the data has not received permission from the author (no attempt made, not that it was refused), most of my uses I feel fall under fair use and do not violate copyright, but you will need to decide for yourself and your applications.
}
\usage{
state.vbm
}
\description{
A SpatialPolygonsDataFrame object (for use with the maptools package) to plot a Visibility Based Map.
}
\details{
A SpatialPolygonsDataFrame object (for use with the maptools package) to plot a map of the US states where the sizes of the states have been adjusted to be more equal. 
This map can be useful for plotting state data using colors patterns without the larger states dominating and the smallest states being lost.
The original map is copyrighted by Mark Monmonier.  Official publications based on this map should acknowledge him. Comercial publications of maps based on this probably need permission from him to use.
}
\examples{
if (requireNamespace("sp", quietly = TRUE)) {
  library(sp)
  data(state.vbm)
  plot(state.vbm)

  tmp <- state.x77[, 'HS Grad']
  tmp2 <- cut(tmp, seq(min(tmp), max(tmp), length.out=11),
            include.lowest=TRUE)
  plot(state.vbm, col=cm.colors(10)[tmp2])
}
}
\references{
\url{http://www.markmonmonier.com/index.htm},
\url{http://www.math.yorku.ca/SCS/Gallery/bright-ideas.html}
}
\author{
Greg Snow \email{greg.snow@imail.org} (of this compilation)
}
\keyword{datasets}
\keyword{sp}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/alaska.R
\docType{data}
\name{alaska}
\alias{alaska}
\title{Alaska multipolygon}
\format{Formal class 'sf' [package "sf"]; the data contains a data.frame with 1 obs. of 7 variables:
\itemize{
    \item{GEOID} {character vector of geographic identifiers}
    \item{NAME} {character vector of state names}
    \item{REGION} {character vector of region names}
    \item{AREA} {area in square kilometers of units class}
    \item{total_pop_10} {numerical vector of total population in 2010}
    \item{total_pop_15} {numerical vector of total population in 2015}
    \item{geometry} {sfc_MULTIPOLYGON}
}
The object is in projected coordinates using Alaska Albers (EPSG:3467).}
\source{
\url{https://www.census.gov/geo/maps-data/data/tiger-line.html}
}
\usage{
alaska
}
\description{
The object loaded is a \code{sf} object containing the state of 
Alaska from the US Census Bureau
with a few variables from American Community Survey (ACS)
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(alaska)

  plot(alaska["total_pop_15"])
}
}
\seealso{
See the tigris package: https://cran.r-project.org/package=tigris
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/boston.R
\docType{data}
\name{boston}
\alias{boston}
\alias{boston.c}
\alias{boston.soi}
\alias{boston.utm}
\title{Corrected Boston Housing Data}
\format{This data frame contains the following columns:
\itemize{
        \item{TOWN} {a factor with levels given by town names}
        \item{TOWNNO} {a numeric vector corresponding to TOWN}
        \item{TRACT} {a numeric vector of tract ID numbers}
        \item{LON} {a numeric vector of tract point longitudes in decimal degrees}
        \item{LAT} {a numeric vector of tract point latitudes in decimal degrees}
        \item{MEDV} {a numeric vector of median values of owner-occupied housing
                in USD 1000}
        \item{CMEDV} {a numeric vector of corrected median values of
                owner-occupied housing in USD 1000}
        \item{CRIM} {a numeric vector of per capita crime}
        \item{ZN} {a numeric vector of proportions of residential land zoned
                for lots over 25000 sq. ft per town (constant for all Boston tracts)}
        \item{INDUS} {a numeric vector of proportions of non-retail business
                acres per town (constant for all Boston tracts)}
        \item{CHAS} {a factor with levels 1 if tract borders Charles River;
                0 otherwise}
        \item{NOX} {a numeric vector of nitric oxides concentration (parts per
                                                                    10 million) per town}
        \item{RM} {a numeric vector of average numbers of rooms per dwelling}
        \item{AGE} {a numeric vector of proportions of owner-occupied units
                built prior to 1940}
        \item{DIS} {a numeric vector of weighted distances to five Boston
                employment centres}
        \item{RAD} {a numeric vector of an index of accessibility to radial
                highways per town (constant for all Boston tracts)}
        \item{TAX} {a numeric vector full-value property-tax rate per USD
                10,000 per town (constant for all Boston tracts)}
        \item{PTRATIO} {a numeric vector of pupil-teacher ratios per town
                (constant for all Boston tracts)}
        \item{B} {a numeric vector of \code{1000*(Bk - 0.63)^2} where Bk is the
                proportion of blacks}
        \item{LSTAT} {a numeric vector of percentage values of lower status
                population}
}}
\source{
\url{http://lib.stat.cmu.edu/datasets/boston_corrected.txt}
}
\description{
The \code{boston.c} data frame has 506 rows and 20 columns. It contains the Harrison and Rubinfeld (1978) data corrected for a few minor errors and augmented with the latitude and longitude of the observations. Gilley and Pace also point out that MEDV is censored, in that median values at or over USD 50,000 are set to USD 50,000. The original data set without the corrections is also included in package \code{mlbench} as \code{BostonHousing}. In addition, a matrix of tract point coordinates projected to UTM zone 19 is included as \code{boston.utm}, and a sphere of influence neighbours list as \code{boston.soi}.
}
\note{
Details of the creation of the tract shapefile given in final don't run block; tract boundaries for 1990: http://www.census.gov/geo/cob/bdy/tr/tr90shp/tr25_d90_shp.zip, counties in the BOSTON SMSA http://www.census.gov/population/metro/files/lists/historical/63mfips.txt; tract conversion table 1980/1970: \url{https://www.icpsr.umich.edu/icpsrweb/ICPSR/studies/7913?q=07913&permit[0]=AVAILABLE}, \url{http://www.icpsr.umich.edu/cgi-bin/bob/zipcart2?path=ICPSR&study=7913&bundle=all&ds=1&dups=yes}. The shapefile contains corrections and extra variables (tract 3592 is corrected to 3593; the extra columns are:
 \itemize{
   \item{units}{number of single family houses}
   \item{cu5k}{count of units under USD 5,000}
   \item{c5_7_5}{counts USD 5,000 to 7,500}
   \item{C*_*}{interval counts}
   \item{co50k}{count of units over USD 50,000}
   \item{median}{recomputed median values}
   \item{BB}{recomputed black population proportion}
   \item{censored}{whether censored or not}
   \item{NOXID}{NOX model zone ID}
   \item{POP}{tract population}
 }
}
\examples{
if (requireNamespace("spdep", quietly = TRUE)) {
  library(spdep)
  data(boston)
  hr0 <- lm(log(MEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2) +
                    AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT), data = boston.c)
  summary(hr0)
  logLik(hr0)
  gp0 <- lm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2) +
                    AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT), data = boston.c)
  summary(gp0)
  logLik(gp0)
  lm.morantest(hr0, nb2listw(boston.soi))
}
\dontrun{
library(rgdal)
boston.tr <- readOGR(system.file("shapes/boston_tracts.shp",
                           package="spData")[1])
boston_nb <- poly2nb(boston.tr)
}
\dontrun{
if (requireNamespace("spatialreg", quietly = TRUE)) {
  library(spatialreg)
  gp1 <- errorsarlm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2)
                             + I(RM^2) +  AGE + log(DIS) + log(RAD) +
                              TAX + PTRATIO + B + log(LSTAT),
                             data=boston.c, nb2listw(boston.soi), method="Matrix", 
                             control=list(tol.opt = .Machine$double.eps^(1/4)))
  summary(gp1)
  gp2 <- lagsarlm(log(CMEDV) ~ CRIM + ZN + INDUS + CHAS + I(NOX^2) + I(RM^2)
                  +  AGE + log(DIS) + log(RAD) + TAX + PTRATIO + B + log(LSTAT),
                  data=boston.c, nb2listw(boston.soi), method="Matrix")
  summary(gp2)
}
}

}
\references{
Harrison, David, and Daniel L. Rubinfeld, Hedonic Housing Prices and the Demand for Clean Air, \emph{Journal of Environmental Economics and Management}, Volume 5, (1978), 81-102. Original data.

Gilley, O.W., and R. Kelley Pace, On the Harrison and Rubinfeld Data, \emph{Journal of Environmental Economics and Management}, 31 (1996),403-405. Provided corrections and examined censoring.

Pace, R. Kelley, and O.W. Gilley, Using the Spatial Configuration of the Data to Improve Estimation,  \emph{Journal of the Real Estate Finance and Economics}, 14 (1997), 333-340.

Bivand, Roger. Revisiting the Boston data set - Changing the units of observation affects estimated willingness to pay for clean air. REGION, v. 4, n. 1, p. 109-127, 2017. \url{http://openjournals.wu.ac.at/ojs/index.php/region/article/view/107}.
}
\keyword{datasets}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grain.R
\docType{data}
\name{grain.tif}
\alias{grain.tif}
\title{Artificial raster dataset representing grain sizes}
\description{
The ratified raster dataset represents grain sizes with the
  three classes clay, silt and sand, and WGS84 as a coordinate reference
  system.
}
\examples{
system.file("raster/grain.tif", package = "spData")
}
\keyword{datasets}
\keyword{raster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getisord.R
\docType{data}
\name{getisord}
\alias{getisord}
\alias{go_x}
\alias{go_y}
\alias{go_xyz}
\title{Getis-Ord remote sensing example data}
\format{This data frame contains the following columns:
\itemize{
        \item{x} {grid eastings}
        \item{y} {grid northings}
        \item{val} {remote sensing values}
}}
\source{
Getis, A. and Ord, J. K. 1996 Local spatial statistics: an overview. In P. Longley and M. Batty (eds) \emph{Spatial analysis: modelling in a GIS environment} (Cambridge: Geoinformation International), 266.
}
\description{
The \code{go_xyz} data frame has 256 rows and 3 columns. Vectors \code{go_x} and \code{go_y} are of length 16 and give the centres of the grid rows and columns, 30m apart. The data start from the bottom left, Getis and Ord start from the top left - so their 136th grid cell is our 120th.
}
\examples{
data(getisord)
image(go_x, go_y, t(matrix(go_xyz$val, nrow = 16, ncol=16, byrow = TRUE)), asp = 1)
text(go_xyz$x, go_xyz$y, go_xyz$val, cex = 0.7)
polygon(c(195, 225, 225, 195), c(195, 195, 225, 225), lwd = 2)
title(main = "Getis-Ord 1996 remote sensing data")

}
\keyword{datasets}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lnd.R
\docType{data}
\name{lnd}
\alias{lnd}
\title{The boroughs of London}
\format{\itemize{
    \item{NAME} {Borough name}
    \item{GSS_CODE} {Official code}
    \item{HECTARES} {How many hectares}
    \item{NONLD_AREA} {Area outside London}
    \item{ONS_INNER} {Office for national statistics code}
    \item{SUB_2009} {Empty column}
    \item{SUB_2006} {Empty column}
    \item{geometry} {sfc_MULTIPOLYGON}
}}
\source{
\url{https://github.com/Robinlovelace/Creating-maps-in-R}
}
\usage{
lnd
}
\description{
Polygons representing large administrative zones in London
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(lnd)
  summary(lnd)
  plot(st_geometry(lnd))
}
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/worldbank_df.R
\docType{data}
\name{worldbank_df}
\alias{worldbank_df}
\title{World Bank data}
\format{Formal class 'data.frame'; the data contains a data.frame with 177 obs. of 7 variables:
\itemize{
    \item{name} {character vector of country names}
    \item{iso_a2} {character vector of ISO 2 character country codes}
    \item{HDI} {human development index (HDI)}
    \item{urban_pop} {urban population}
    \item{unemployment} {unemployment, total (\% of total labor force)}
    \item{pop_growth} {population growth (annual \%)}
    \item{literacy} {adult literacy rate, population 15+ years, both sexes (\%)}
}}
\source{
\url{http://data.worldbank.org/}
}
\usage{
worldbank_df
}
\description{
The object loaded is a \code{data.frame} object containing data from World Bank
}
\examples{
data(worldbank_df)
# or
worldbank_df <- read.csv(system.file("misc/worldbank_df.csv", package="spData"))

summary(worldbank_df)

}
\seealso{
See the wbstats package: https://cran.r-project.org/web/packages/wbstats
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/jenks71.R
\docType{data}
\name{jenks71}
\alias{jenks71}
\title{Illinois 1959 county gross farm product value per acre}
\format{A data frame with 102 observations on the following 2 variables.
\itemize{
        \item{\code{jenks71}} {a numeric vector: Per acre value of gross farm products in dollars by county for Illinois in #' 1959}
        \item{\code{area}} {a numeric vector: county area in square miles}
}}
\source{
Jenks, G. F., Caspall, F. C., 1971. "Error on choroplethic maps: definition, measurement, reduction". Annals, Association of American Geographers, 61 (2), 217--244
}
\usage{
jenks71
}
\description{
Classic data set for the choice of class intervals for choropleth maps.
}
\examples{
data(jenks71)
jenks71
}
\keyword{datasets}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hopkins.R
\docType{data}
\name{hopkins}
\alias{hopkins}
\title{Hopkins burnt savanna herb remains}
\format{num [1:40, 1:40] 0 0 0 0 0 0 0 0 0 1 ...}
\source{
Upton, G., Fingleton, B. 1985 Spatial data analysis by example: point pattern and quatitative data, Wiley, pp. 38--39.
}
\usage{
hopkins
}
\description{
A 20m square is divided into 40 by 40 0.5m quadrats. Observations are in tens of grams of herb remains, 0 being from 0g to less than 10g, and so on. Analysis was mostly conducted using the interior 32 by 32 grid.
}
\examples{
data(hopkins)
image(1:32, 1:32, hopkins[5:36,36:5], breaks=c(-0.5, 3.5, 20),
      col=c("white", "black"))
}
\references{
Hopkins, B., 1965 Observations on savanna burning in the Olokemeji Forest Reserve, Nigeria. Journal of Applied Ecology, 2, 367--381.
}
\keyword{datasets}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/elev.R
\docType{data}
\name{elev}
\alias{elev}
\title{Artificial elevation raster data set}
\format{An object of class \code{RasterLayer} of dimension 6 x 6 x 1.}
\usage{
elev
}
\description{
The raster data represents elevation in meters and uses WGS84 as
  a coordinate reference system.
}
\examples{
if (requireNamespace("raster", quietly = TRUE)) {
  library(raster)
  data(elev)
  elev
}
}
\keyword{datasets}
\keyword{raster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/huddersfield.R
\docType{data}
\name{huddersfield}
\alias{huddersfield}
\title{Prevalence of respiratory symptoms}
\format{A data frame with 71 observations on the following 2 variables.
\itemize{
        \item{\code{cases}} {Prevalence of at least mild conditions}
        \item{\code{total}} {Number of questionnaires returned}
}}
\source{
Martuzzi M, Elliott P (1996) Empirical Bayes estimation of small area prevalence of non-rare conditions, Statistics in Medicine 15, 1867--1873, pp. 1870--1871.
}
\usage{
huddersfield
}
\description{
Prevalence of respiratory symptoms in 71 school catchment areas in Huddersfield, Northern England
}
\examples{
data(huddersfield)
str(huddersfield)
}
\keyword{datasets}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/us_states_df.R
\docType{data}
\name{us_states_df}
\alias{us_states_df}
\title{the American Community Survey (ACS) data}
\format{Formal class 'data.frame'; the data contains a data.frame with 51 obs. of 5 variables:
\itemize{
    \item{state} {character vector of state names}
    \item{median_income_10} {numerical vector of median income in 2010}
    \item{median_income_15} {numerical vector of median income in 2010}
    \item{poverty_level_10} {numerical vector of number of people with income below poverty level in 2010}
    \item{poverty_level_15} {numerical vector of number of people with income below poverty level in 2015}
}}
\source{
\url{https://www.census.gov/programs-surveys/acs/}
}
\usage{
us_states_df
}
\description{
The object loaded is a \code{data.frame} object containing the US states data from the American Community Survey (ACS)
}
\examples{
data(us_states_df)

summary(us_states_df)

}
\seealso{
See the tidycensus package: https://cran.r-project.org/package=tidycensus
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/used.cars.R
\docType{data}
\name{used.cars}
\alias{used.cars}
\alias{usa48.nb}
\title{US 1960 used car prices}
\format{This data frame contains the following columns:
\itemize{
\item{tax.charges} {taxes and delivery charges for 1955-9 new cars}
\item{price.1960} {1960 used car prices by state}
}}
\source{
Hanna, F. A. 1966 Effects of regional differences in taxes and transport charges on automobile consumption, in Ostry, S., Rhymes, J. K. (eds) Papers on regional statistical studies, Toronto: Toronto University Press, pp. 199-223.
}
\usage{
used.cars
}
\description{
The \code{used.cars} data frame has 48 rows and 2 columns. The data set includes a neighbours list for the 48 states excluding DC from poly2nb().
}
\examples{
if (requireNamespace("spdep", quietly = TRUE)) {
  library(spdep)
  data(used.cars)
  moran.test(used.cars$price.1960, nb2listw(usa48.nb))
  moran.plot(used.cars$price.1960, nb2listw(usa48.nb),
           labels=rownames(used.cars))
  uc.lm <- lm(price.1960 ~ tax.charges, data=used.cars)
  summary(uc.lm)

  lm.morantest(uc.lm, nb2listw(usa48.nb))
  lm.morantest.sad(uc.lm, nb2listw(usa48.nb))
  lm.LMtests(uc.lm, nb2listw(usa48.nb))
  if (requireNamespace("spatialreg", quietly = TRUE)) {
    library(spatialreg)
    uc.err <- errorsarlm(price.1960 ~ tax.charges, data=used.cars,
                       nb2listw(usa48.nb), tol.solve=1.0e-13, 
                       control=list(tol.opt=.Machine$double.eps^0.3))
    summary(uc.err)
    uc.lag <- lagsarlm(price.1960 ~ tax.charges, data=used.cars,
                     nb2listw(usa48.nb), tol.solve=1.0e-13, 
                     control=list(tol.opt=.Machine$double.eps^0.3))
    summary(uc.lag)
    uc.lag1 <- lagsarlm(price.1960 ~ 1, data=used.cars,
                      nb2listw(usa48.nb), tol.solve=1.0e-13, 
                      control=list(tol.opt=.Machine$double.eps^0.3))
    summary(uc.lag1)
    uc.err1 <- errorsarlm(price.1960 ~ 1, data=used.cars,
                        nb2listw(usa48.nb), tol.solve=1.0e-13, 
                        control=list(tol.opt=.Machine$double.eps^0.3))
    summary(uc.err1)
  }
}
}
\references{
Hepple, L. W. 1976 A maximum likelihood model for econometric estimation with spatial series, in Masser, I (ed) Theory and practice in regional science, London: Pion, pp. 90-104.
}
\keyword{datasets}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nz.R
\docType{data}
\name{nz}
\alias{nz}
\alias{new_zealand}
\title{Regions in New Zealand}
\format{FORMAT:
\itemize{
    \item{Name} {Name}
    \item{Island} {Island}
    \item{Land_area} {Land area}
    \item{Population} {Population}
    \item{Median_income} {Median income (NZD)}
    \item{Sex_ratio} {Sex ratio (male/female)}
    \item{geom} {sfc_MULTIPOLYGON}
}}
\source{
\url{https://www.stats.govt.nz}

\url{https://en.wikipedia.org/wiki/Regions_of_New_Zealand}
}
\usage{
nz
}
\description{
Polygons representing the 16 regions of New Zealand (2018).
See \url{https://en.wikipedia.org/wiki/Regions_of_New_Zealand} for a description of these regions
and \url{https://www.stats.govt.nz} for information on the data source
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  summary(nz)
  plot(nz)
}
\dontrun{
# Find "Regional Council 2018 Clipped (generalised)"
# select the GeoPackage option in the "Vectors/tables" dropdown
# at https://datafinder.stats.govt.nz/data/ (requires registration)
# Save the result as:
unzip("statsnzregional-council-2018-clipped-generalised-GPKG.zip")
library(sf)
library(tidyverse)
nz_full = st_read("regional-council-2018-clipped-generalised.gpkg")
print(object.size(nz_full), units = "Kb") # 14407.2 Kb
nz = rmapshaper::ms_simplify(nz_full, keep = 0.001, sys = TRUE)
print(object.size(nz), units = "Kb") # 39.9 Kb
names(nz)
nz$REGC2018_V1_00_NAME
nz = filter(nz, REGC2018_V1_00_NAME != "Area Outside Region") \%>\%
        select(Name = REGC2018_V1_00_NAME, `Land_area` = LAND_AREA_SQ_KM)
# regions basic info
# devtools::install_github("hadley/rvest")
library(rvest)
doc = read_html("https://en.wikipedia.org/wiki/Regions_of_New_Zealand") \%>\%
        html_nodes("div table")
tab = doc[[3]] \%>\% html_table()
tab = tab \%>\% select(Name = Region, Population = `Population[20]`, Island)
tab = tab \%>\% mutate(Population = str_replace_all(Population, ",", "")) \%>\%
        mutate(Population = as.numeric(Population)) \%>\%
        mutate(Name = str_remove_all(Name, " \\\\([1-9]\\\\)?.+"))
nz$Name = as.character(nz$Name)
nz$Name = str_remove(nz$Name, " Region")
nz$Name \%in\% tab$Name
# regions additional info
library(nzcensus)
nz_add_data = REGC2013 \%>\% 
        select(Name = REGC2013_N, Median_income = MedianIncome2013, 
               PropFemale2013, PropMale2013) \%>\% 
        mutate(Sex_ratio = PropMale2013 / PropFemale2013) \%>\% 
        mutate(Name = gsub(" Region", "", Name)) \%>\% 
        select(Name, Median_income, Sex_ratio)
# data join
nz = left_join(nz, tab, by = "Name") \%>\% 
        left_join(nz_add_data, by = "Name") \%>\% 
        select(Name, Island, Land_area, Population, Median_income, Sex_ratio)
}
}
\seealso{
See the nzcensus package: https://github.com/ellisp/nzelect
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SplashDams.R
\docType{data}
\name{SplashDams}
\alias{SplashDams}
\title{Data for Splash Dams in western Oregon}
\format{Formal class 'SpatialPointsDataFrame with 232 obs. of  6 variables:
\itemize{
\item{streamName} {}
\item{locationCode} {}
\item{height} {}
\item{lastDate} {}
\item{owner} {}
\item{datesUsed} {}
}}
\source{
R. R. Miller (2010) Is the Past Present? Historical Splash-dam Mapping and Stream Disturbance Detection in the Oregon Coastal Province. MSc. thesis, Oregon State University; packaged by Jonathan Callahan
}
\usage{
SplashDams
}
\description{
Data for Splash Dams in western Oregon
}
\examples{
if (requireNamespace("sp", quietly = TRUE)) {
  library(sp)
  data(SplashDams)
  plot(SplashDams, axes=TRUE)
}
}
\references{
\url{http://www.fs.fed.us/pnw/lwm/aem/docs/burnett/miller_rebecca_r2010rev.pdf}
}
\keyword{datasets}
\keyword{sp}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/urban_agglomerations.R
\docType{data}
\name{urban_agglomerations}
\alias{urban_agglomerations}
\title{Major urban areas worldwide}
\format{Selected variables:
\itemize{
    \item{year} {Year of population estimate}
    \item{country_code} {Code of country}
    \item{urban_agglomeration} {Name of the urban agglomeration}
    \item{population_millions} {Estimated human population}
    \item{geometry} {sfc_POINT}
}}
\source{
\url{https://population.un.org/wup/}
}
\usage{
urban_agglomerations
}
\description{
Dataset in a 'long' form from the United Nations
population division with projections up to 2050.
Includes only the top 30 largest areas by population at 5 year intervals.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(urban_agglomerations)
}
# Code used to download the data:
\dontrun{
download.file(destfile = "WUP2014-F11a-30_Largest_Cities.xls",
url = "https://esa.un.org/unpd/wup/CD-ROM/WUP2014_XLS_CD_FILES/WUP2014-F11a-30_Largest_Cities.xls")
library(dplyr)
library(sf)
urban_agglomerations = readxl::read_excel("WUP2014-F11a-30_Largest_Cities.xls", skip = 16) \%>\%
    st_as_sf(coords = c("Longitude", "Latitude"), crs = 4326)
names(urban_agglomerations) <- gsub(" ", "_", tolower(names(urban_agglomerations)) ) \%>\% 
        gsub("\\\\(|\\\\)", "", .)
devtools::use_data(urban_agglomerations, overwrite = TRUE)
file.remove("WUP2014-F11a-30_Largest_Cities.xls")
}
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coffee_data.R
\docType{data}
\name{coffee_data}
\alias{coffee_data}
\title{World coffee production data}
\format{A data frame (tibble) with 58 for the following 12 variables:
\itemize{
\item{name_long} {name of country or coffee variety}
\item{coffee_production_2016} {production in 2016}
\item{coffee_production_2017} {production in 2017}
}}
\source{
The International Coffee Organization (ICO). See http://www.ico.org/ and
http://www.ico.org/prices/m1-exports.pdf
}
\usage{
coffee_data
}
\description{
A tiny dataset containing estimates of global coffee in thousands of 60 kg bags produced by country.
Purpose: teaching **not** research.
}
\details{
The examples section shows how this can be joined with spatial data to create a simple map.
}
\examples{
head(coffee_data)
\dontrun{
library(tidyverse)
library(sf)
# found by searching for "global coffee data"
u = "http://www.ico.org/prices/m1-exports.pdf"
download.file(u, "data.pdf", mode = "wb")
install.packages("pdftables") # requires api key
pdftables::convert_pdf(input_file = "data.pdf", output_file = "coffee-data-messy.csv")
d = read_csv("coffee-data-messy.csv")
file.remove("coffee-data-messy.csv")
file.remove("data.pdf")
coffee_data = slice(d, -c(1:9)) \%>\% 
        select(name_long = 1, coffee_production_2016 = 2, coffee_production_2017 = 3) \%>\% 
        filter(!is.na(coffee_production_2016)) \%>\% 
        mutate_at(2:3, str_replace, " ", "") \%>\% 
        mutate_at(2:3, as.integer)
world_coffee = left_join(world, coffee_data)
plot(world_coffee[c("coffee_production_2016", "coffee_production_2017")])
b = c(0, 500, 1000, 2000, 3000)
library(tmap)
tm_shape(world_coffee) +
  tm_fill("coffee_production_2017", title = "Thousand 60kg bags", breaks = b,
          textNA = "No data", colorNA = NULL)
tmap_mode("view") # for an interactive version
}
}
\keyword{datasets}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nydata.R
\docType{data}
\name{nydata}
\alias{nydata}
\alias{NY_data}
\alias{listw_NY}
\title{New York leukemia data}
\format{
A data frame with 281 observations on the following 12 variables, and the binary coded spatial weights used in the source.
\itemize{
\item{AREANAME: name of census tract}
\item{AREAKEY: unique FIPS code for each tract}
\item{X: x-coordinate of tract centroid (in km)}
\item{Y: y-coordinate of tract centroid (in km)}
\item{POP8: population size (1980 U.S. Census)}
\item{TRACTCAS: number of cases 1978-1982}
\item{PROPCAS: proportion of cases per tract}
\item{PCTOWNHOME: percentage of people in each tract owning their own home}
\item{PCTAGE65P: percentage of people in each tract aged 65 or more}
\item{Z: ransformed propoprtions}
\item{AVGIDIST: average distance between centroid and TCE sites}
\item{PEXPOSURE: "exposure potential": inverse distance between each census tract centroid and the nearest TCE site, IDIST, transformed via log(100*IDIST)}
\item{Cases: as TRACTCAS with more digits}
\item{Xm: X in metres}
\item{Ym: Y in metres}
\item{Xshift: feature offset}
\item{Yshift: feature offset}
}
}
\source{
http://www.sph.emory.edu/~lwaller/ch9index.htm
}
\usage{
nydata
}
\description{
New York leukemia data taken from the data sets supporting Waller and Gotway 2004 (the data should be loaded by running \code{example(NY_data)} to demonstrate spatial data import techniques)
}
\details{
The examples section shows how the DBF files from the book website for Chapter 9 were converted into the \code{nydata} data frame and the \code{listw_NY} spatial weights list. The \code{shapes} directory includes the original version of the UTM18 census tract boundaries imported from BNA format (http://sedac.ciesin.columbia.edu/ftpsite/pub/census/usa/tiger/ny/bna_st/t8_36.zip) before the OGR/GDAL BNA driver was available. The \code{NY8_utm18} shapefile was constructed using a bna2mif converter and converted to shapefile format after adding data using \code{writeOGR}. The new file \code{NY8_bna_utm18.gpkg} has been constructed from the original BNA file, but read using the OGR BNA driver with GEOS support. The NY8 shapefile and GeoPackage NY8_utm18.gpkg include invalid polygons, but because the OGR BNA driver may have GEOS support (used here), the tract polygon objects in NY8_bna_utm18.gpkg are valid.
}
\examples{
## NY leukemia
\donttest{
if (requireNamespace("sf", quietly = TRUE)) {
library(foreign)
nydata <- read.dbf(system.file("misc/nydata.dbf", package="spData")[1])
nydata <- sf::st_as_sf(nydata, coords=c("X", "Y"), remove=FALSE)
plot(sf::st_geometry(nydata))

nyadjmat <- as.matrix(read.dbf(system.file("misc/nyadjwts.dbf",
                                           package="spData")[1])[-1])
ID <- as.character(names(read.dbf(system.file("misc/nyadjwts.dbf",
                                              package="spData")[1]))[-1])
identical(substring(ID, 2, 10), substring(as.character(nydata$AREAKEY), 2, 10))

if (requireNamespace("sf", quietly = TRUE)) {
library(spdep)
listw_NY <- mat2listw(nyadjmat, as.character(nydata$AREAKEY), style="B")
}
}
}
}
\references{
Waller, L. and C. Gotway (2004) \emph{Applied Spatial Statistics for Public Health Data}. New York: John Wiley and Sons.
}
\keyword{datasets}
\keyword{foreign}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/world.R
\docType{data}
\name{world}
\alias{world}
\alias{wrld}
\title{World country polygons}
\format{Formal class 'sf' [package "sf"]; the data contains a data.frame with 177 obs. of 11 variables:
\itemize{
    \item{iso_a2} {character vector of ISO 2 character country codes}
    \item{name_long} {character vector of country names}
    \item{continent} {character vector of continent names}
    \item{region_un} {character vector of region names}
    \item{subregion} {character vector of subregion names}
    \item{type} {character vector of type names}
    \item{area_km2} {integer vector of area values}
    \item{pop} {integer vector of population in 2014}
    \item{lifeExp} {integer vector of life expectancy at birth in 2014}
    \item{gdpPercap} {integer vector of per-capita GDP in 2014}
    \item{geom} {sfc_MULTIPOLYGON}
}
The object is in geographical coordinates using the WGS84 datum.}
\source{
\url{http://www.naturalearthdata.com/}

\url{http://data.worldbank.org/}
}
\usage{
world
}
\description{
The object loaded is a \code{sf} object containing a world map data from Natural Earth with a few variables from World Bank
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(world)
  # or
  world <- st_read(system.file("shapes/world.gpkg", package="spData"))

  plot(world)
}
}
\seealso{
See the rnaturalearth package: https://cran.r-project.org/package=rnaturalearth
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auckland.R
\docType{data}
\name{auckland}
\alias{auckland}
\alias{auckland.nb}
\alias{auckpolys}
\title{Marshall's infant mortality in Auckland dataset}
\format{This data frame contains the following columns:
\itemize{
        \item{Easting} {a numeric vector of x coordinates in an unknown spatial reference system}
        \item{Northing} {a numeric vector of y coordinates in an unknown spatial reference system}
        \item{M77_85} {a numeric vector of counts of infant (under 5 years of age) deaths in Auckland, 1977-1985}
        \item{Und5_81} {a numeric vector of population under 5 years of age at the 1981 Census}
}}
\source{
Marshall R M (1991) Mapping disease and mortality rates using Empirical Bayes Estimators, Applied Statistics, 40, 283--294; Bailey T, Gatrell A (1995) Interactive Spatial Data Analysis, Harlow: Longman --- INFOMAP data set used with permission.
}
\usage{
auckland
}
\description{
(Use \code{example(auckland)} to load the data from shapefile and generate neighbour list on the fly).  The \code{auckland} data frame has 167 rows (census area units --- CAU) and 4 columns. The dataset also includes the "nb" object \code{auckland.nb} of neighbour relations based on contiguity, and the "polylist" object \code{auckpolys} of polygon boundaries for the CAU. The \code{auckland} data frame includes the following columns:
}
\details{
The contiguous neighbours object does not completely replicate results in the sources, and was reconstructed from \code{auckpolys}; examination of figures in the sources suggests that there are differences in detail, although probably not in substance.
}
\examples{
if (requireNamespace("rgdal", quietly = TRUE)) {
  library(rgdal)
  auckland <- readOGR(system.file("shapes/auckland.shp", package="spData")[1])
  plot(auckland)
  if (requireNamespace("spdep", quietly = TRUE)) {
    library(spdep)
    auckland.nb <- poly2nb(auckland)
  }
}

}
\keyword{datasets}
\keyword{sp}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/house.R
\docType{data}
\name{house}
\alias{house}
\alias{LO_nb}
\alias{trMat}
\title{Lucas county OH housing}
\format{Formal class 'SpatialPointsDataFrame' [package "sp"] with 5 slots. The data slot is a data frame with 25357 observations on the following 24 variables.
\itemize{
        \item{price} {a numeric vector}
        \item{yrbuilt} {a numeric vector}
        \item{stories} {a factor with levels \code{one} \code{bilevel} \code{multilvl} \code{one+half} \code{two}     \code{two+half} \code{three}}
        \item{TLA} {a numeric vector}
        \item{wall} {a factor with levels \code{stucdrvt} \code{ccbtile} \code{metlvnyl} \code{brick} \code{stone} \code{wood} \code{partbrk}}
        \item{beds} {a numeric vector}
        \item{baths} {a numeric vector}
        \item{halfbaths} {a numeric vector}
        \item{frontage} {a numeric vector}
        \item{depth} {a numeric vector}
        \item{garage} {a factor with levels \code{no garage} \code{basement} \code{attached} \code{detached} \code{carport}}
        \item{garagesqft} {a numeric vector}
        \item{rooms} {a numeric vector}
        \item{lotsize} {a numeric vector}
        \item{sdate} {a numeric vector}
        \item{avalue} {a numeric vector}
        \item{s1993} {a numeric vector}
        \item{s1994} {a numeric vector}
        \item{s1995} {a numeric vector}
        \item{s1996} {a numeric vector}
        \item{s1997} {a numeric vector}
        \item{s1998} {a numeric vector}
        \item{syear} {a factor with levels \code{1993} \code{1994} \code{1995} \code{1996} \code{1997} \code{1998}}
        \item{age} {a numeric vector}
}
Its projection is \code{CRS(+init=epsg:2834)}, the Ohio North State Plane.}
\source{
Dataset included in the Spatial Econometrics toolbox for Matlab, \url{http://www.spatial-econometrics.com/html/jplv7.zip}.
}
\usage{
house
}
\description{
Data on 25,357 single family homes sold in Lucas County, Ohio, 1993-1998 from the county auditor, together with an \code{nb} neighbour object constructed as a sphere of influence graph from projected coordinates.
}
\examples{
if (requireNamespace("sp", quietly = TRUE)) {
  library(sp)
  data(house)
  str(house)
  plot(house)
}
}
\keyword{datasets}
\keyword{sp}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/elev.R
\docType{data}
\name{elev.tif}
\alias{elev.tif}
\title{Artificial elevation raster data set}
\description{
The raster data represents elevation in meters and uses WGS84 as
  a coordinate reference system.
}
\examples{
system.file("raster/elev.tif", package = "spData")
}
\keyword{datasets}
\keyword{raster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wheat.R
\docType{data}
\name{wheat}
\alias{wheat}
\title{Mercer and Hall wheat yield data}
\format{The format of the object generated by running \code{data(wheat)} is a three column data frame made available by Hongfei Li. The example section shows how to convert this to the object used in demonstrating the \code{aple} function, and is a formal class 'SpatialPolygonsDataFrame' [package "sp"] with 5 slots; the data slot is a data frame with 500 observations on the following 6 variables.
\itemize{
        \item{lat} {local coordinates northings ordered north to south}
        \item{yield} {Mercer and Hall wheat yield data}
        \item{r} {rows south to north; levels in distance units of plot centres}
        \item{c} {columns west to east; levels in distance units of plot centres}
        \item{lon} {local coordinates eastings}
        \item{lat1} {local coordinates northings ordered south to north}
}}
\source{
Cressie, N. A. C. (1993) Statistics for Spatial Data. Wiley, New York, p. 455.
}
\usage{
wheat
}
\description{
Mercer and Hall wheat yield data, based on version in Cressie (1993), p. 455.
}
\note{
The value of 4.03 was changed to 4.33 (wheat[71,]) 13 January 2014; thanks to Sandy Burden; cross-checked with http://www.itc.nl/personal/rossiter/teach/R/mhw.csv, which agrees.
}
\examples{
\dontrun{
data(wheat)
wheat$lat1 <- 69 - wheat$lat
wheat$r <- factor(wheat$lat1)
wheat$c <- factor(wheat$lon)
wheat_sp <- wheat
coordinates(wheat_sp) <- c("lon", "lat1")
wheat_spg <- wheat_sp

gridded(wheat_spg) <- TRUE
wheat_spl <- as(wheat_spg, "SpatialPolygons")
df <- as(wheat_spg, "data.frame")
row.names(df) <- sapply(slot(wheat_spl, "polygons"),
                        function(x) slot(x, "ID"))
wheat <- SpatialPolygonsDataFrame(wheat_spl, data=df)
}

if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  wheat <- st_read(system.file("shapes/wheat.shp", package="spData"))
  plot(wheat)
}
}
\references{
Mercer, W. B. and Hall, A. D. (1911) The experimental error of field trials. Journal of Agricultural Science 4, 107-132.
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nc.sids.R
\docType{data}
\name{nc.sids}
\alias{nc.sids}
\alias{ncCR85.nb}
\alias{ncCC89.nb}
\alias{sidspolys}
\alias{sidscents}
\title{North Carolina SIDS data}
\format{This data frame contains the following columns:
\itemize{
        \item{SP_ID} {SpatialPolygons ID}
        \item{CNTY_ID} {county ID}
        \item{east} {eastings, county seat, miles, local projection}
        \item{north} {northings, county seat, miles, local projection}
        \item{L_id} {Cressie and Read (1985) L index}
        \item{M_id} {Cressie and Read (1985) M index}
        \item{names} {County names}
        \item{AREA} {County polygon areas in degree units}
        \item{PERIMETER} {County polygon perimeters in degree units}
        \item{CNTY_} {Internal county ID}
        \item{NAME} {County names}
        \item{FIPS} {County ID}
        \item{FIPSNO} {County ID}
        \item{CRESS_ID} {Cressie papers ID}
        \item{BIR74} {births, 1974-78}
        \item{SID74} {SID deaths, 1974-78}
        \item{NWBIR74} {non-white births, 1974-78}
        \item{BIR79} {births, 1979-84}
        \item{SID79} {SID deaths, 1979-84}
        \item{NWBIR79} {non-white births, 1979-84}
}}
\source{
Cressie, N (1991), \emph{Statistics for spatial data}. New York: Wiley, pp. 386--389; Cressie, N, Chan NH (1989) Spatial modelling of regional variables. \emph{Journal of the American Statistical Association}, 84, 393--401; Cressie, N, Read, TRC (1985) Do sudden infant deaths come in clusters? \emph{Statistics and Decisions} Supplement Issue 2, 333--349; http://sal.agecon.uiuc.edu/datasets/sids.zip.
}
\usage{
nc.sids
}
\description{
(Use \code{example(nc.sids)} to read the data set from shapefile, together with import of two different list of neighbours). 
The \code{nc.sids} data frame has 100 rows and 21 columns. It contains data given in Cressie (1991, pp. 386-9), Cressie and Read (1985) and Cressie and Chan (1989) on sudden infant deaths in North Carolina for 1974-78 and 1979-84. The data set also contains the neighbour list given by Cressie and Chan (1989) omitting self-neighbours (ncCC89.nb), and the neighbour list given by Cressie and Read (1985) for contiguities (ncCR85.nb). The data are ordered by county ID number, not alphabetically as in the source tables \code{sidspolys} is a "polylist" object of polygon boundaries, and \code{sidscents} is a matrix of their centroids.
}
\examples{
if (requireNamespace("rgdal", quietly = TRUE)) {
  library(rgdal)
  if (requireNamespace("spdep", quietly = TRUE)) {
    library(spdep)
    nc.sids <- readOGR(system.file("shapes/sids.shp", package="spData")[1])
    proj4string(nc.sids) <- CRS("+proj=longlat +ellps=clrk66")
    row.names(nc.sids) <- as.character(nc.sids$FIPS)
    rn <- row.names(nc.sids)
    ncCC89_nb <- read.gal(system.file("weights/ncCC89.gal", package="spData")[1],
                          region.id=rn)
    ncCR85_nb <- read.gal(system.file("weights/ncCR85.gal", package="spData")[1],
                          region.id=rn)
                          
    plot(nc.sids, border="grey")
    plot(ncCR85_nb, coordinates(nc.sids), add=TRUE, col="blue")
    plot(nc.sids, border="grey")
    plot(ncCC89_nb, coordinates(nc.sids), add=TRUE, col="blue")
  }
}
}
\keyword{datasets}
\keyword{spdep}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/depmunic.R
\docType{data}
\name{depmunic}
\alias{depmunic}
\title{Municipality departments of Athens (Sf)}
\format{
An sf object of 7 polygons with the following 7 variables.
\itemize{
  \item{num_dep}{An unique identifier for each municipality department.}
  \item{airbnb }{The number of airbnb properties in 2017}
  \item{museums }{The number of museums}
  \item{population }{The population recorded in census at 2011.}
  \item{pop_rest }{The number of citizens that the origin is a non european country.}
  \item{greensp}{The area of green spaces (unit: square meters).}
  \item{area}{The area of the polygon (unit: square kilometers). }
}
}
\usage{
depmunic
}
\description{
The geographic boundaries of departments (sf) of the municipality of Athens. This is accompanied by various characteristics in these areas.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(depmunic)
  
  depmunic$foreigners <- 100*depmunic$pop_rest/depmunic$population
  plot(depmunic["foreigners"], key.pos=1)
}
}
\seealso{
properties
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cycle_hire_osm.R
\docType{data}
\name{cycle_hire_osm}
\alias{cycle_hire_osm}
\title{Cycle hire points in London from OSM}
\format{\itemize{
    \item{osm_id} {The OSM ID}
    \item{name} {The name of the cycle point}
    \item{capacity} {How many bikes it can take}
    \item{cyclestreets_id} {The ID linked to cyclestreets' photomap}
    \item{description} {Additional description of points}
    \item{geometry} {sfc_POINT}
}}
\source{
\url{http://www.openstreetmap.org}
}
\usage{
cycle_hire_osm
}
\description{
Dataset downloaded using the osmdata package
representing cycle hire points accross London.
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(cycle_hire_osm)
  # or
  cycle_hire_osm <- st_read(system.file("shapes/cycle_hire_osm.geojson", package="spData"))
  
  plot(cycle_hire_osm)
}

# Code used to download the data:
\dontrun{
library(osmdata)
library(dplyr)
library(sf)
q = add_osm_feature(opq = opq("London"), key = "network", value = "tfl_cycle_hire")
lnd_cycle_hire = osmdata_sf(q)
cycle_hire_osm = lnd_cycle_hire$osm_points
nrow(cycle_hire_osm)
plot(cycle_hire_osm)
cycle_hire_osm = dplyr::select(cycle_hire_osm, osm_id, name, capacity, 
                               cyclestreets_id, description) \%>\%
  mutate(capacity = as.numeric(capacity))
names(cycle_hire_osm)
nrow(cycle_hire_osm)
}
}
\seealso{
See the osmdata package: https://cran.r-project.org/package=osmdata
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/us_states.R
\docType{data}
\name{us_states}
\alias{us_states}
\title{US states polygons}
\format{Formal class 'sf' [package "sf"]; the data contains a data.frame with 49 obs. of 7 variables:
\itemize{
    \item{GEOID} {character vector of geographic identifiers}
    \item{NAME} {character vector of state names}
    \item{REGION} {character vector of region names}
    \item{AREA} {area in square kilometers of units class}
    \item{total_pop_10} {numerical vector of total population in 2010}
    \item{total_pop_15} {numerical vector of total population in 2015}
    \item{geometry} {sfc_MULTIPOLYGON}
}
The object is in geographical coordinates using the NAD83 datum.}
\source{
\url{https://www.census.gov/geo/maps-data/data/tiger-line.html}
}
\usage{
us_states
}
\description{
The object loaded is a \code{sf} object containing the contiguous United States data from the US Census Bureau
with a few variables from American Community Survey (ACS)
}
\examples{
if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  data(us_states)

  plot(us_states["REGION"])
}
}
\seealso{
See the tigris package: https://cran.r-project.org/package=tigris
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/elect80.R
\docType{data}
\name{elect80}
\alias{elect80}
\alias{elect80_lw}
\alias{k4}
\alias{dll}
\alias{e80_queen}
\title{1980 Presidential election results}
\format{A SpatialPointsDataFrame with 3107 observations on the following 7 variables.
\itemize{
        \item{FIPS} {a factor of county FIPS codes}
        \item{long} {a numeric vector of longitude values}
        \item{lat} {a numeric vector of latitude values}
        \item{pc_turnout} {Votes cast as proportion of population over age 19 eligible to vote}
        \item{pc_college} {Population with college degrees as proportion of population over age 19 eligible to vote}
        \item{pc_homeownership} {Homeownership as proportion of population over age 19 eligible to vote}
        \item{pc_income} {Income per capita of population over age 19 eligible to vote}
}}
\source{
Pace, R. Kelley and Ronald Barry. 1997. "Quick Computation of Spatial Autoregressive Estimators", in Geographical Analysis; sourced from the data folder in the Spatial Econometrics Toolbox for Matlab, \url{http://www.spatial-econometrics.com/html/jplv7.zip}, files \code{elect.dat} and \code{elect.ford} (with the final line dropped).
}
\usage{
elect80
}
\description{
A data set for 1980 Presidential election results covering 3,107 US counties using geographical coordinates. In addition, three spatial neighbour objects, \code{k4} not using Great Circle distances, \code{dll} using Great Circle distances, and \code{e80_queen} of Queen contiguities for equivalent County polygons taken from file \code{co1980p020.tar.gz} on the USGS National Atlas site, and a spatial weights object imported from \code{elect.ford} - a 4-nearest neighbour non-GC row-standardised object, but with coercion to symmetry.
}
\examples{
if (requireNamespace("sp", quietly = TRUE)) {
  library(sp)
  data(elect80)
  summary(elect80)
  plot(elect80)
}
}
\keyword{datasets}
\keyword{sp}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/congruent.R
\docType{data}
\name{congruent}
\alias{congruent}
\alias{incongruent}
\alias{aggregating_zones}
\title{Datasets to illustrate the concept of spatial congruence}
\format{Simple feature geographic data in a projected CRS (OSGB) with random values assigned
for teaching purposes.}
\source{
\url{https://en.wikipedia.org/wiki/ONS_coding_system}
}
\usage{
congruent
}
\description{
Sample of old (incongruent) and new (congruent) administrative zones
from UK statistical agencies
}
\examples{
if(requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  plot(aggregating_zones$geometry, lwd = 5)
  plot(congruent$geometry, add = TRUE, border = "green", lwd = 2)
  plot(incongruent$geometry, add = TRUE, border = "blue", col = NA)
  rbind(congruent, incongruent)
}
# Code used to download the data:
\dontrun{
devtools::install_github("robinlovelace/ukboundaries")
library(sf)
library(tmap)
library(dplyr)
library(ukboundaries)
sel = grepl("003|004", msoa2011_lds$geo_label)
aggregating_zones = st_transform(msoa2011_lds[sel, ], 27700)
# find lsoas in the aggregating_zones
lsoa_touching = st_transform(lsoa2011_lds, 27700)[aggregating_zones, ]
lsoa_cents = st_centroid(lsoa_touching)
lsoa_cents = lsoa_cents[aggregating_zones, ]
sel = lsoa_touching$geo_code \%in\% lsoa_cents$geo_code
# same for ed zones
ed_touching = st_transform(ed1981, 27700)[aggregating_zones, ]
ed_cents = st_centroid(ed_touching)
ed_cents = ed_cents[aggregating_zones, ]
incongruent_agg_ed = ed_touching[ed_cents, ]
set.seed(2017)
incongruent_agg_ed$value = rnorm(nrow(incongruent_agg_ed), mean = 5)
congruent = aggregate(incongruent_agg_ed["value"], lsoa_touching[sel, ], mean)
congruent$level = "Congruent"
congruent = congruent[c("level", "value")]
incongruent_cents = st_centroid(incongruent_agg_ed)
aggregating_value = st_join(incongruent_cents, congruent)$value.y
incongruent_agg = aggregate(incongruent_agg_ed["value"], list(aggregating_value), FUN = mean)
incongruent_agg$level = "Incongruent"
incongruent = incongruent_agg[c("level", "value")]
summary(st_geometry_type(congruent))
summary(st_geometry_type(incongruent))
incongruent = st_cast(incongruent, "MULTIPOLYGON")
summary(st_geometry_type(incongruent))
summary(st_geometry_type(aggregating_zones))
devtools::use_data(congruent, overwrite = TRUE)
devtools::use_data(incongruent, overwrite = TRUE)
devtools::use_data(aggregating_zones, overwrite = TRUE)
}
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/baltimore.R
\docType{data}
\name{baltimore}
\alias{baltimore}
\title{House sales prices, Baltimore, MD 1978}
\format{
A data frame with 211 observations on the following 17 variables.
\itemize{
        \item{STATION: a numeric vector}
        \item{PRICE: a numeric vector}
        \item{NROOM: a numeric vector}
        \item{DWELL: a numeric vector}
        \item{NBATH: a numeric vector}
        \item{PATIO: a numeric vector}
        \item{FIREPL: a numeric vector}
        \item{AC: a numeric vector}
        \item{BMENT: a numeric vector}
        \item{NSTOR: a numeric vector}
        \item{GAR: a numeric vector}
        \item{AGE: a numeric vector}
        \item{CITCOU: a numeric vector}
        \item{LOTSZ: a numeric vector}
        \item{SQFT: a numeric vector}
        \item{X: a numeric vector}
        \item{Y: a numeric vector}
}
}
\source{
Prepared by Luc Anselin. Original data made available by Robin Dubin, Weatherhead School of Management, Case Western Research University, Cleveland, OH. http://sal.agecon.uiuc.edu/datasets/baltimore.zip
}
\usage{
baltimore
}
\description{
House sales price and characteristics for a spatial hedonic regression, Baltimore, MD 1978. X,Y on Maryland grid, projection type unknown.
}
\examples{
data(baltimore)
str(baltimore)

if (requireNamespace("sf", quietly = TRUE)) {
  library(sf)
  baltimore_sf <- baltimore |> st_as_sf(coords = c("X","Y"))
  plot(baltimore_sf["PRICE"])
}
}
\references{
Dubin, Robin A. (1992). Spatial autocorrelation and neighborhood quality. Regional Science and Urban Economics 22(3), 433-452.
}
\keyword{datasets}
\keyword{sf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eire.R
\docType{data}
\name{eire}
\alias{eire}
\alias{eire.df}
\alias{eire.polys.utm}
\alias{eire.coords.utm}
\alias{eire.nb}
\title{Eire data sets}
\format{This data frame contains the following columns:
\itemize{
        \item{A} {Percentage of sample with blood group A}
        \item{towns} {Towns/unit area}
        \item{pale} {Beyond the Pale 0, within the Pale 1}
        \item{size} {number of blood type samples}
        \item{ROADACC} {arterial road network accessibility in 1961}
        \item{OWNCONS} {percentage in value terms of gross agricultural output of each county consumed by itself}
        \item{POPCHG} {1961 population as percentage of 1926}
        \item{RETSALE} {value of retail sales British Pound000}
        \item{INCOME} {total personal income British Pound000}
        \item{names} {County names}
}}
\source{
Upton and Fingleton 1985, - Bailey and Gatrell 1995, ch. 1 for blood group data, Cliff and Ord (1973), p. 107 for remaining variables (also after O'Sullivan, 1968). Polygon borders and Irish data sourced from Michael Tiefelsdorf's SPSS Saddlepoint bundle, originally hosted at: http://geog-www.sbs.ohio-state.edu/faculty/tiefelsdorf/GeoStat.htm.
}
\description{
The Eire data set has been converted to shapefile format and placed in the etc/shapes directory. The initial data objects are now stored as a SpatialPolygonsDataFrame object, from which the contiguity neighbour list is recreated. For purposes of record, the original data set is retained. 
The \code{eire.df} data frame has 26 rows and 9 columns. In addition, polygons of the 26 counties are provided as a multipart polylist in eire.polys.utm (coordinates in km, projection UTM zone 30). Their centroids are in eire.coords.utm. The original Cliff and Ord binary contiguities are in eire.nb.
}
\examples{
\dontrun{
library(maptools)
library(rgdal)
library(spdep)
eire <- readOGR(system.file("shapes/eire.shp", package="spData")[1])
eire.nb <- poly2nb(eire)

data(eire)
# Eire physical anthropology blood group data
summary(eire$A)
brks <- round(fivenum(eire$A), digits=2)
cols <- rev(heat.colors(4))
plot(eire, col=cols[findInterval(eire$A, brks, all.inside=TRUE)])
title(main="Percentage with blood group A in Eire")
legend(x=c(-50, 70), y=c(6120, 6050), leglabs(brks), fill=cols, bty="n")

plot(eire)
plot(eire.nb, coordinates(eire), add=TRUE)

lA <- lag.listw(nb2listw(eire.nb), eire$A)
summary(lA)
moran.test(eire$A, nb2listw(eire.nb))
geary.test(eire$A, nb2listw(eire.nb))
cor(lA, eire$A)
moran.plot(eire$A, nb2listw(eire.nb), labels=eire$names)
A.lm <- lm(A ~ towns + pale, data=eire)
summary(A.lm)
res <- residuals(A.lm)
brks <- c(min(res),-2,-1,0,1,2,max(res))
cols <- rev(cm.colors(6))

plot(eire, col=cols[findInterval(res, brks, all.inside=TRUE)])
title(main="Regression residuals")
legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cols, bty="n")

lm.morantest(A.lm, nb2listw(eire.nb))
lm.morantest.sad(A.lm, nb2listw(eire.nb))
lm.LMtests(A.lm, nb2listw(eire.nb), test="LMerr")

# Eire agricultural data
brks <- round(fivenum(eire$OWNCONS), digits=2)
cols <- grey(4:1/5)
plot(eire, col=cols[findInterval(eire$OWNCONS, brks, all.inside=TRUE)])
title(main="Percentage own consumption of agricultural produce")
legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cols, bty="n")

moran.plot(eire$OWNCONS, nb2listw(eire.nb))
moran.test(eire$OWNCONS, nb2listw(eire.nb))
e.lm <- lm(OWNCONS ~ ROADACC, data=eire)
res <- residuals(e.lm)
brks <- c(min(res),-2,-1,0,1,2,max(res))
cols <- rev(cm.colors(6))
plot(eire, col=cols[findInterval(res, brks, all.inside=TRUE)])
title(main="Regression residuals")
legend(x=c(-50, 70), y=c(6120, 6050), legend=leglabs(brks), fill=cm.colors(6), bty="n")

lm.morantest(e.lm, nb2listw(eire.nb))
lm.morantest.sad(e.lm, nb2listw(eire.nb))
lm.LMtests(e.lm, nb2listw(eire.nb), test="LMerr")
print(localmoran.sad(e.lm, eire.nb, select=1:length(slot(eire, "polygons"))))
}
}
\keyword{datasets}
\keyword{sp}
\keyword{spdep}
